

import java.awt.EventQueue;
import java.net.URL;
import java.util.Date;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JDialog;
import javax.swing.JMenuBar;
import javax.swing.JOptionPane;
import javax.swing.JToolBar;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JSeparator;
import javax.swing.JButton;

import org.freepascal.rtl.TObject;

import SecureBlackbox.Base.*;
import SecureBlackbox.FTPSServer.*;

import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;


public class Main extends JDialog implements TagEvent {

	private static final long serialVersionUID = 1L;
	private JTable tableConnections;
	private static JTable tableLog;
    private TElSimpleFTPSServer ElSimpleFTPSServer;
	private JButton btnStart;
	private JButton btnStop;
	private ConnTableModel cmodel;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					Main dialog = new Main();
					dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
					dialog.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the dialog.
	 */
	public Main() {
		addWindowListener(new WindowAdapter() {
			@Override
			public void windowClosing(WindowEvent e) {
				stopClick();
				System.exit(0);
			}
		});	
		
		setResizable(false);
		setTitle("FTPSServer Java demo");
		setBounds(100, 100, 689, 513);
		
		JMenuBar menuBar = new JMenuBar();
		setJMenuBar(menuBar);
		
		JMenu mnServer = new JMenu("Server");
		menuBar.add(mnServer);
		
		JMenuItem mntmStart = new JMenuItem("Start");
		mnServer.add(mntmStart);
		
		JMenuItem mntmStop = new JMenuItem("Stop");
		mnServer.add(mntmStop);
		
		JSeparator separator = new JSeparator();
		mnServer.add(separator);
		
		JMenuItem mntmExit = new JMenuItem("Exit");
		mntmExit.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				dispose();
				System.exit(0);
			}
		});
		mnServer.add(mntmExit);
		
		JMenu mnHelp = new JMenu("Help");
		menuBar.add(mnHelp);
		
		JMenuItem mntmAbout = new JMenuItem("About");
		mntmAbout.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				AboutDialog dlg = new AboutDialog();
				dlg.setModal(true);
				dlg.setVisible(true);
			}
		});
		mnHelp.add(mntmAbout);
		getContentPane().setLayout(null);
		
		JToolBar toolBar = new JToolBar();
		toolBar.setFloatable(false);
		toolBar.setBounds(0, 0, 681, 27);
		getContentPane().add(toolBar);
		
		btnStart = new JButton("");
		btnStart.setFocusable(false);
		btnStart.setFocusPainted(false);
		btnStart.setRequestFocusEnabled(false);
		btnStart.setIcon(getIcon("start"));
		btnStart.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				startClick();
			}
		});
		toolBar.add(btnStart);
		
		btnStop = new JButton("");
		btnStop.setFocusable(false);
		btnStop.setFocusPainted(false);
		btnStop.setRequestFocusEnabled(false);
		btnStop.setIcon(getIcon("stop"));
		btnStop.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				stopClick();
			}
		});
		toolBar.add(btnStop);
		
		JButton btnSettings = new JButton("");
		btnSettings.setFocusable(false);
		btnSettings.setFocusPainted(false);
		btnSettings.setRequestFocusEnabled(false);
		btnSettings.setIcon(getIcon("settings"));
		btnSettings.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (SettingsDialog.changeSettings())
					ElSimpleFTPSServer.getUsers().save("Users.dat", "asd$%:sss");
			}
		});
		toolBar.add(btnSettings);
		
		JButton btnExit = new JButton("");
		btnExit.setFocusable(false);
		btnExit.setFocusPainted(false);
		btnExit.setRequestFocusEnabled(false);
		btnExit.setIcon(getIcon("exit"));
		btnExit.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				dispose();
				System.exit(0);
			}
		});
		toolBar.add(btnExit);
		
		JScrollPane scrollPane = new JScrollPane();
		scrollPane.setBounds(0, 27, 681, 325);
		getContentPane().add(scrollPane);
		
		cmodel = new ConnTableModel();
		tableConnections = new JTable(cmodel);
		tableConnections.setFillsViewportHeight(true);
		scrollPane.setViewportView(tableConnections);
		
		JScrollPane scrollPane_1 = new JScrollPane();
		scrollPane_1.setBounds(0, 355, 681, 110);
		getContentPane().add(scrollPane_1);
		
		tableLog = new JTable(new LogTableModel());
		tableLog.setFillsViewportHeight(true);
		scrollPane_1.setViewportView(tableLog);
		
		init();
	}

	private Icon getIcon(String name) {
		URL resPath = getClass().getResource(name + ".ico");
		if (resPath == null) return new ImageIcon();
		return new ImageIcon(resPath);
	}

	protected void stopClick() {
        if (ElSimpleFTPSServer.getActive())
        {
            ElSimpleFTPSServer.stop();
            btnStop.setEnabled(false);
            btnStart.setEnabled(true);
            Log("Server stopped.", false);
        }
	}

	protected void startClick() {
        if (!ElSimpleFTPSServer.getActive())
        {
			DiskFileSystemAdapter Adapter = new DiskFileSystemAdapter(this);
			ElSimpleFTPSServer.setFileSystemAdapter(Adapter);
		
            ElSimpleFTPSServer.setPort(DemoSettings.getSettings().getListeningPort());
            ElSimpleFTPSServer.setHost(DemoSettings.getSettings().getListeningAddress());
            ElSimpleFTPSServer.setPassiveModeHost(DemoSettings.getSettings().getPassiveModeHost());
            ElSimpleFTPSServer.setImplicitSSL(DemoSettings.getSettings().getImplicitSSL());
            ElSimpleFTPSServer.setAllowAnonymous(DemoSettings.getSettings().getAllowAnonymous());
            ElSimpleFTPSServer.setCertStorage(DemoSettings.getSettings().getCertStorage());
            ElSimpleFTPSServer.setDataPortRangeFrom(DemoSettings.getSettings().getPortRangeFrom());
            ElSimpleFTPSServer.setDataPortRangeTo(DemoSettings.getSettings().getPortRangeTo());
            ElSimpleFTPSServer.start();
            btnStop.setEnabled(true);
            btnStart.setEnabled(false);
            Log("Server started.", false);
        }
	}

	void init() {
		#error Please pick the evaluation license key from <SecureBlackbox>\LicenseKey.txt file and place it here. If the evaluation key expires, you can request an extension using the form on https://www.eldos.com/sbb/keyreq/
		SBUtils.setLicenseKey("<put the key here>");
        
		DemoSettings.getSettings().Load();
        Log("Settings loaded", false);
		
        if (DemoSettings.getSettings().getSettingsFound() == false) 
		{
			showMessage("Welcome to the ElFTPSServer Demo Application!\n" + 
				"Thank you for your interest in our products.\n\n" +
				"First of all, you need to create at least one user account.\n\n" + 
				"After clicking the OK button you will be redirected to the\n" +
				"User settings window.");
			SettingsDialog.changeSettings();
		}
		
		ElSimpleFTPSServer = new TElSimpleFTPSServer();
		ElSimpleFTPSServer.getUsers().load("Users.dat", "asd$%:sss");
		initEvents();
	}
	
	private void initEvents() {
		ElSimpleFTPSServer.setOnTransferProgress(new TSBFTPSServerTransferProgressEvent(onTransferProgress));
		ElSimpleFTPSServer.setOnTransferCompleted(new TNotifyEvent(onTransferCompleted));
		ElSimpleFTPSServer.setOnCommandProcessed(new TSBFTPSServerCommandProcessedEvent(onCommandProcessed));
		ElSimpleFTPSServer.setOnNewConnection(new TSBSimpleFTPSServerNewConnectionEvent(onNewConnection));
		ElSimpleFTPSServer.setOnCommandReceived(new TSBFTPSServerCommandReceivedEvent(onCommandReceived));
		ElSimpleFTPSServer.setOnAuthAttempt(new TSBSimpleFTPSServerAuthAttemptEvent(onAuthAttempt));
		ElSimpleFTPSServer.setOnBeforeNewConnection(new TSBSimpleFTPSServerBeforeNewConnectionEvent(onBeforeNewConnection));
		ElSimpleFTPSServer.setOnCloseConnection(new TSBSimpleFTPSServerCloseConnectionEvent(onCloseConnection));
	}
	
	TSBSimpleFTPSServerCloseConnectionEvent.Callback onCloseConnection = new TSBSimpleFTPSServerCloseConnectionEvent.Callback() {
		
		public void tsbSimpleFTPSServerCloseConnectionEventCallback(TObject sender,
				TElSimpleFTPSServerSessionThread session) {
    		cmodel.remove(session);
            Log("Client disconnected.");
		}
	};
	
	TSBSimpleFTPSServerBeforeNewConnectionEvent.Callback onBeforeNewConnection = new TSBSimpleFTPSServerBeforeNewConnectionEvent.Callback() {
		
		public void tsbSimpleFTPSServerBeforeNewConnectionEventCallback(
				TObject sender, String remoteIP, int remotePort, TSBBoolean reject) {
			reject.value = false;
		}
	};
	
	TSBSimpleFTPSServerAuthAttemptEvent.Callback onAuthAttempt = new TSBSimpleFTPSServerAuthAttemptEvent.Callback() {
		
		public void tsbSimpleFTPSServerAuthAttemptEventCallback(TObject sender,
				String username, String password, TSBBoolean allow) {
			allow.value = false;
            TElSimpleFTPSServerSessionThread session = (TElSimpleFTPSServerSessionThread)sender;
                if (allow.value)
                    Log("Access granted to user " + username, false);
                else
                    Log("Access denied for user " + username, true);

                cmodel.change(session, "-", username, "", session.getFTPSServer().getLastCommand(), "");    
			
		}
	};
	
	TSBFTPSServerCommandReceivedEvent.Callback onCommandReceived = new TSBFTPSServerCommandReceivedEvent.Callback() {
		
		public void tsbftpsServerCommandReceivedEventCallback(TObject sender,
				String command, String parameters, TSBBoolean cancel) {
            TElSimpleFTPSServerSessionThread session = (TElSimpleFTPSServerSessionThread)sender;
            cmodel.change(session, "-", "-", "-", command + ' ' + parameters, "");    

			cancel.value = false;
		}
	};
	
	TSBSimpleFTPSServerNewConnectionEvent.Callback onNewConnection = new TSBSimpleFTPSServerNewConnectionEvent.Callback() {
		
		public void tsbSimpleFTPSServerNewConnectionEventCallback(TObject sender,
				TElSimpleFTPSServerSessionThread session) {
            int Opts = SBFTPSServer.fsoPlainLogin | SBFTPSServer.fsoEncryption |
                    SBFTPSServer.fsoAuth | SBFTPSServer.fsoClearControlChannel | SBFTPSServer.fsoClearDataChannel |
                    SBFTPSServer.fsoEncryptedDataChannel;

                if (DemoSettings.getSettings().getRequireTLS())
                {
                    Opts = Opts & (~SBFTPSServer.fsoPlainLogin);
                    Opts = Opts & (~SBFTPSServer.fsoClearControlChannel);                   
                }

                if (DemoSettings.getSettings().getRequireTLSForData())
                    Opts = Opts & (~SBFTPSServer.fsoClearDataChannel);

                session.getFTPSServer().setSecurityOptions(Opts);

                cmodel.add(session);
                cmodel.change(session, session.getSocket().getRemoteAddress() + ":" + session.getSocket().getPort(), "", "", "", "");
                Log("Client connected from " + session.getSocket().getRemoteAddress() + ":" + session.getSocket().getPort());                
		}
	};
	
	TSBFTPSServerCommandProcessedEvent.Callback onCommandProcessed = new TSBFTPSServerCommandProcessedEvent.Callback() {
		
		public void tsbftpsServerCommandProcessedEventCallback(TObject sender,
				String command, int replyCode) {
            TElSimpleFTPSServerSessionThread session = (TElSimpleFTPSServerSessionThread)sender;
            cmodel.change(session,  "-", "-", session.getCurrentDirectory(), command, "Finished : " + replyCode);
		}
	};

	TNotifyEvent.Callback onTransferCompleted = new TNotifyEvent.Callback() {
		
		public void tNotifyEventCallback(TObject sender) {
			Log("Transfer completed");
		}
	};
	
	TSBFTPSServerTransferProgressEvent.Callback onTransferProgress = new TSBFTPSServerTransferProgressEvent.Callback() {
		
		public void tsbftpsServerTransferProgressEventCallback(TObject sender,
				long progress, long total, TSBBoolean cancel) {
			TElSimpleFTPSServerSessionThread session = (TElSimpleFTPSServerSessionThread)sender;
            if (total > 0)
            	cmodel.change(session, "-", "-", "-", "-", (progress * 100 / total) + "% of " + (total / 1024) + "Kb");
            else
            	cmodel.change(session, "-", "-", "-", "-", (progress / 1024) + "Kb");
			cancel.value = false;
		}
	};
	
	public static void Log(String msg, boolean isError) 
	{
		if (tableLog == null){
			showMessage(msg);
		} else {
			LogTableModel model = (LogTableModel)tableLog.getModel();
			model.addRow(new Date(), msg, isError ? "Eror" : "Info");
			scrollToEndTable(tableLog);
		}
	}

	protected void Log(String msg) {
		Log(msg, false);
	}

	private static void scrollToEndTable(JTable tbl) {
		tbl.scrollRectToVisible(tbl.getCellRect(tbl.getRowCount() - 1, tbl.getColumnCount(), true));		
	}
	
	public static void showMessage(String msg) {
		JOptionPane.showMessageDialog(null, msg, "FTPSServer demo", JOptionPane.INFORMATION_MESSAGE);
	}

	public void OnWriteFileTag(Object Sender, String Path, String TagName,
			String TagValue, TSBInteger resultCode) {
		resultCode.value = 0;
	}

	public void OnReadFileTag(Object Sender, String Path, String TagName,
			TSBString TagValue, TSBInteger resultCode) {
		resultCode.value = 0;
	}

	public void OnDeleteFileTag(Object Sender, String Path, String TagName, TSBInteger resultCode) {
		resultCode.value = 0;
	}
}