

import java.awt.EventQueue;

import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JProgressBar;
import javax.swing.JTextField;
import javax.swing.JButton;

import org.freepascal.rtl.TObject;

import SecureBlackbox.Base.SBUtils;
import SecureBlackbox.Base.TElFileStream;
import SecureBlackbox.Base.TElStringList;
import SecureBlackbox.Base.TElX509Certificate;
import SecureBlackbox.Base.TSBBoolean;
import SecureBlackbox.Base.TSBHTTPVersion;
import SecureBlackbox.Base.TSBProgressEvent;
import SecureBlackbox.HTTPClient.TElHTTPSClient;
import SecureBlackbox.SSLCommon.SBSSLConstants;
import SecureBlackbox.SSLCommon.TSBCertificateValidateEvent;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;


public class Main extends JDialog {

	private static final long serialVersionUID = 1L;
	private JTextField tbURL;
	private JTextField tbPath;
	private JProgressBar pbUploading;
	TElHTTPSClient HTTPSClient;
	
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					Main dialog = new Main();
					dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
					dialog.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the dialog.
	 */
	public Main() {
		setTitle("HTTP Post");
		setBounds(100, 100, 427, 127);
		getContentPane().setLayout(null);
		
		JLabel lblUrl = new JLabel("URL");
		lblUrl.setBounds(10, 11, 46, 14);
		getContentPane().add(lblUrl);
		
		JLabel lblPath = new JLabel("Path");
		lblPath.setBounds(10, 36, 46, 14);
		getContentPane().add(lblPath);
		
		pbUploading = new JProgressBar();
		pbUploading.setBounds(53, 63, 260, 23);
		getContentPane().add(pbUploading);
		
		tbURL = new JTextField();
		tbURL.setText("http://localhost/upload/simple_upload.php");
		tbURL.setBounds(53, 8, 356, 20);
		getContentPane().add(tbURL);
		tbURL.setColumns(10);
		
		JButton btnBrowse = new JButton("Browse");
		btnBrowse.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				tbPath.setText(getOpenFileName());
			}
		});
		btnBrowse.setBounds(323, 32, 86, 23);
		getContentPane().add(btnBrowse);
		
		tbPath = new JTextField();
		tbPath.setBounds(53, 36, 260, 20);
		getContentPane().add(tbPath);
		tbPath.setColumns(10);
		
		JButton btnPost = new JButton("Post");
		btnPost.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				postClick();
			}
		});
		btnPost.setBounds(323, 63, 86, 23);
		getContentPane().add(btnPost);

		init();
	}

	private void init() {
		#error Please pick the evaluation license key from <SecureBlackbox>\LicenseKey.txt file and place it here. If the evaluation key expires, you can request an extension using the form on https://www.eldos.com/sbb/keyreq/
		SBUtils.setLicenseKey("<put the key here>");

		HTTPSClient = new TElHTTPSClient();
		HTTPSClient.setHTTPProxyPort(3128);
		HTTPSClient.setHTTPVersion(TSBHTTPVersion.hvHTTP11);
		HTTPSClient.setSendBufferSize(65535);
		HTTPSClient.setSocksAuthentication(0);
		HTTPSClient.setVersions((short)(SBSSLConstants.sbTLS1 | SBSSLConstants.sbTLS11 | SBSSLConstants.sbTLS12));
		HTTPSClient.setWebTunnelPort(3128);
		HTTPSClient.setOnProgress(new TSBProgressEvent(onProgress));
		HTTPSClient.setOnCertificateValidate(new TSBCertificateValidateEvent(onCertificateValidate));		
	}

	TSBCertificateValidateEvent.Callback onCertificateValidate = new TSBCertificateValidateEvent.Callback() {
		
		public void tsbCertificateValidateEventCallback(TObject sender,
				TElX509Certificate cert, TSBBoolean accept) {
			// NEVER do this in real life since this makes HTTPS security void. 
			// Instead validate the certificate as described on http://www.eldos.com/sbb/articles/1966.php
			accept.value = true;
		}
	};
	
	TSBProgressEvent.Callback onProgress = new TSBProgressEvent.Callback() {
		
		public void tsbProgressEventCallback(TObject sender, long total, long current, TSBBoolean cancel) {
			if (total != -1)
			{
				pbUploading.setMaximum((int) (total / 1024));					
				pbUploading.setValue((int) (current / 1024));
			}

			cancel.value = false;
		}
	};
	String getOpenFileName(){
		JFileChooser fc = new JFileChooser();
	    int returnVal = fc.showOpenDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

		return "";
	} 

	protected void postClick() {
		if (tbPath.getText().length() > 0 && tbURL.getText().length() > 0)
		{
			java.lang.Thread t = new Thread(new Runnable() {
				
				public void run() {
					upload();
				}
			});
			
			t.start();
		}
	}
	
	private void upload() {
		String FilePath = tbPath.getText().trim();
		TElFileStream stream = new TElFileStream(FilePath, "r", true);
		TElStringList SL = new TElStringList();
		SL.add("upload", "Upload");

		pbUploading.setMinimum(0);
		pbUploading.setMaximum((int) (stream.getLength() / 1024));
		pbUploading.setValue(0);
		
		try
		{
			HTTPSClient.postWebForm(tbURL.getText(), SL, "userfile", FilePath, stream, "", true);
		}
		catch (Exception E)
		{
			showErrorMessage("Exception happened during HTTP post: " + E.getMessage());
		}
		
		stream.Free();		
	}

	public void showErrorMessage(String msg) {
		JOptionPane.showMessageDialog(null, msg, getTitle(), JOptionPane.ERROR_MESSAGE);
	}
}
