import java.awt.EventQueue;
import java.io.File;

import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JButton;
import javax.swing.JTextField;
import javax.swing.JTextArea;
import javax.swing.JCheckBox;
import javax.swing.JFileChooser;
import javax.swing.JPasswordField;
import javax.swing.JOptionPane;

import org.freepascal.rtl.TObject;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

import SecureBlackbox.Base.*;
import SecureBlackbox.MIME.*;
import SecureBlackbox.PKI.*;
import SecureBlackbox.HTTPClient.*;
import SecureBlackbox.HTTPCommon.*;
import SecureBlackbox.SMIME.*;
import SecureBlackbox.SMIMECAdES.*;

public class SMIMECAdESDemo extends javax.swing.JDialog {
	
	private static final long serialVersionUID = 1L;
	private TElMemoryCertStorage fStorage = new TElMemoryCertStorage();

	private boolean certificateLoad(){
		  fStorage.clear();
		  TElX509Certificate Cert = new TElX509Certificate();
		  String pass = fPass.getText();
		  int res = Cert.loadFromFileAuto(fCert.getText(), pass);
    	   if (res == 0){
    		   fStorage.add(Cert, true);
    		   return true;
    	   }
    	   JOptionPane.showMessageDialog(null, "Error Loading certificate. Error code: " + res, getTitle(), JOptionPane.ERROR_MESSAGE);    	   
    	   return false;

	}
	
	private static JTextArea fMsgText;
	private static JTextField fFrom;
	private static JTextField fTo;
	private static JCheckBox fClearFormat;
	private static JTextField fTSP;
	private static JTextField fCert;
	private static JPasswordField fPass;
	
	private void signAndSave(){
		
		JFileChooser fc = new JFileChooser();
		
		if (fc.showSaveDialog(this) == JFileChooser.APPROVE_OPTION)
			cadesAssemble(fc.getSelectedFile().getPath());
		
		
	}
	
	private void loadAndValidate(){
		JFileChooser fc = new JFileChooser();
		
		if (fc.showOpenDialog(this) == JFileChooser.APPROVE_OPTION)
			CAdESParse(fc.getSelectedFile().getPath());
	}
	
	private void openCert(){
		JFileChooser fc = new JFileChooser();
		if (fc.showOpenDialog(this) == JFileChooser.APPROVE_OPTION)
			fCert.setText(fc.getSelectedFile().getPath());
	}
	
	public SMIMECAdESDemo() {
		setTitle("CAdES demo Application");
		setBounds(100, 100, 600, 420);
		getContentPane().setLayout(null);
		
		JLabel Lbl1 = new JLabel("Message text");
		Lbl1.setBounds(10, 5, 150, 15);
		getContentPane().add(Lbl1);
		
		fMsgText = new JTextArea();
		getContentPane().add(fMsgText);
		fMsgText.setBounds(10, 25, 200, 200);
		fMsgText.setText("This is message text");

		JLabel Lbl2 = new JLabel("From");
		Lbl2.setBounds(240, 5, 150, 15);
		getContentPane().add(Lbl2);
		
		fFrom = new JTextField();
		getContentPane().add(fFrom);
		fFrom.setText("info@eldos.com");
		fFrom.setBounds(240, 25, 310, 20);

		JLabel Lbl3 = new JLabel("To");
		Lbl3.setBounds(240, 50, 150, 15);
		getContentPane().add(Lbl3);
		
		fTo = new JTextField();
		getContentPane().add(fTo);
		fTo.setText("test@eldos.com");
		fTo.setBounds(240, 70, 310, 20);

		fClearFormat = new JCheckBox("Sign Clear Format");
		getContentPane().add(fClearFormat);
		fClearFormat.setBounds(240, 100, 150, 20);
		
		JButton btSave = new JButton("Sign and Save");
		btSave.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				signAndSave();
			}
		});
		btSave.setBounds(400, 100, 150, 20);
		getContentPane().add(btSave);

		JButton btLoad = new JButton("Load and Validate");
		btLoad.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				loadAndValidate();
			}
		});
		btLoad.setBounds(400, 130, 150, 20);
		getContentPane().add(btLoad);
		
		JLabel Lbl4 = new JLabel("TSP Server URL");
		Lbl4.setBounds(10, 230, 150, 15);
		getContentPane().add(Lbl4);
		
		fTSP = new JTextField();
		getContentPane().add(fTSP);
		fTSP.setText("http://tsp.iaik.tugraz.at/tsp/TspRequest");
		fTSP.setBounds(10, 250, 410, 20);
		
		JLabel Lbl5 = new JLabel("Signing certificate");
		Lbl5.setBounds(10, 275, 110, 15);
		getContentPane().add(Lbl5);

		fCert = new JTextField();
		getContentPane().add(fCert);
		fCert.setBounds(10, 295, 400, 20);
		
		JButton btOpenCert = new JButton("Browse...");
		btOpenCert.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				openCert();
			}
		});
		btOpenCert.setBounds(430, 295, 120, 20);
		getContentPane().add(btOpenCert);
		
		JLabel Lbl6 = new JLabel("Certificate password");
		Lbl6.setBounds(10, 320, 150, 15);
		getContentPane().add(Lbl6);
		
		fPass = new JPasswordField();
		getContentPane().add(fPass);
		fPass.setBounds(10, 340, 400, 20);
		
		
	}
	
    private void handleSign(Object Sender, TElCAdESSignatureProcessor Processor){
    	
    	  Processor.setForceSigningCertificateV2(true);
    	  TElHTTPSClient Http = new TElHTTPSClient();
    	  TElHTTPTSPClient Tsp = new TElHTTPTSPClient();
    	  Tsp.setHTTPClient(Http);
    	  Tsp.setURL(fTSP.getText());

    	  Processor.createT(fStorage.getCertificate(0), Tsp);
    	
    	
    }
    private void handleBeforeCheckSign(Object Sender, TElCAdESSignatureProcessor Processor){
    	  // this demo use CAdES - T sign which do not contain revocation info
    	  Processor.setPerformRevocationCheck(false);
    	  // here we can assign custom revocation info
    	  //Processor.CustomRevocationInfo.AddOCSPResponse();
    	  //Processor.CustomRevocationInfo.CRLs.Add()
    	
    }
    
    private void cadesAssemble(String fileName){
    	
    	TElMessage Msg = new TElMessage();
    	Msg.setMainPart(new TElPlainTextPart(), false);
    	TElMessagePartHandlerSMimeCAdES Signer = new TElMessagePartHandlerSMimeCAdES();
        Signer.setUseCAdES(true);
        
        Signer.setOnSign(new TSBSMimeCAdESSign(new TSBSMimeCAdESSign.Callback() {
    		
    		@Override
    		public void tsbsMimeCAdESSignCallback(TObject arg0,
    				TElCAdESSignatureProcessor arg1) {
    			handleSign(arg0, arg1);
    			
    		}
          }));        

        certificateLoad();

        Msg.getFrom().addAddress(fFrom.getText(), fFrom.getText());
        Msg.getTo_().addAddress(fTo.getText(), fTo.getText());
        Msg.getMainPart().setText(fMsgText.getText());
        Msg.setMIMEPrefix("This is a test S/MIME message with CAdES support");

        Signer.setEncoderSigned(true);
        Signer.setEncoderSignOnlyClearFormat(fClearFormat.isSelected());
        Signer.setEncoderSignCertStorage(fStorage);
        Signer.setEncoderMicalg("sha512");
        Signer.setEncoderSignBeforeCrypt(true);

        Signer.setEncoderCrypted(false); // we can also crypt the message
        Signer.setEncoderCryptAlgorithm(SBConstants.SB_ALGORITHM_CNT_AES256);
        Signer.setEncoderCryptCertStorage(fStorage);

        Msg.getMainPart().setMessagePartHandler(Signer);

        TAnsiStringMIMEStream astrm = new TAnsiStringMIMEStream();
		
        if (Msg.assembleMessage(astrm, "", TElHeaderEncoding.he8bit, "", "", false) != 0) {
          JOptionPane.showMessageDialog(null, "Failed to assemble the message", getTitle(), JOptionPane.ERROR_MESSAGE);  
          return;
        }
        
        astrm.saveToFile(fileName);

    
    }
	
	private void CAdESParse(String fileName){
	    if (!certificateLoad())
	    	return;
	    
		TElMessage Msg = new TElMessage("");
			
		TAnsiStringMIMEStream astrm = new TAnsiStringMIMEStream();
		astrm.loadFromFile(fileName);
		astrm.setPosition(0);
			
      if (Msg.parseMessage(astrm, "", "",(short)(SBMIME.mpoStoreStream | SBMIME.mpoLoadData | SBMIME.mpoCalcDataSize | SBMIME.mpoRaiseError), false, false, false) != 0) {
    	  	JOptionPane.showMessageDialog(null, "Failed to parse message", getTitle(), JOptionPane.ERROR_MESSAGE);  
    	  	return;		    	  
      }
		      
      TElMessagePartHandler sgn = Msg.getMainPart().getMessagePartHandler();
      if (!(sgn instanceof TElMessagePartHandlerSMimeCAdES)){
    	  JOptionPane.showMessageDialog(null, "Message not signed", getTitle(), JOptionPane.ERROR_MESSAGE);
    	  return;
      }
      TElMessagePartHandlerSMimeCAdES Signer = (TElMessagePartHandlerSMimeCAdES)(sgn);
      Signer.setUseCAdES(true);
      Signer.setOnValidate(new TSBSMimeCAdESValidate(new TSBSMimeCAdESValidate.Callback() {
		
		@Override
		public void tsbsMimeCAdESValidateCallback(TObject arg0,
				TElCAdESSignatureProcessor arg1) {
			handleBeforeCheckSign(arg0, arg1);
			
		}
      }));
      Signer.setCertificatesStorage(fStorage);
      Signer.decode(false);

      TSBString Text = new TSBString();
      
      if (Msg.getMainPart().getPartsCount() > 0){ 
    	  Msg.getMainPart().getPart(0).getText(Text);
      } else if (Msg.getMainPart().getMessagePartHandler() != null) {
    	  if (Msg.getMainPart().getMessagePartHandler().getDecodedPart().getMessagePartHandler() != null) {
    	  	Msg.getMainPart().getMessagePartHandler().getDecodedPart().getMessagePartHandler().decode(false);
    	  	Msg.getMainPart().getMessagePartHandler().getDecodedPart().getMessagePartHandler().getDecodedPart().getText(Text);
    	  }  else { 
    		  Msg.getMainPart().getMessagePartHandler().getDecodedPart().getText(Text);
    	  }
      } else{
    	  Msg.getMainPart().getText(Text);
      }
      fMsgText.setText(Text.value);
      
      if (Msg.getFrom().getTotalCount() > 0){
    	  fFrom.setText(Msg.getFrom().getAddress(0).getAddress());
      }else{
    	  fFrom.setText("");
      }
      if (Msg.getTo_().getTotalCount() > 0){
    	  fTo.setText(Msg.getTo_().getAddress(0).getAddress());
      }else{
    	  fTo.setText("");
      }
      
      // Main is Signer.DecoderSignIsCorrectly it combines all checks from all parts
      // All others is for current sign part only
      if( !Signer.getDecoderSignIsCorrectly() ||
        (Signer.getCAdESValidity() != TSBCAdESSignatureValidity.asvValid) || (Signer.getCAdESErrorCode() != 0) ||
        (Signer.getCAdESCertValidity() != TSBCertificateValidity.cvOk) || (Signer.getCAdESReason() != 0)){
    	  JOptionPane.showMessageDialog(null, "Invalid sign", getTitle(), JOptionPane.ERROR_MESSAGE);
      }
			
	}
	

	
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		
	        SBMIME.initialize();
		SBSMIMECAdES.initialize();
		
        // Initialize SecureBlackbox JNI library. sbbjni32.dll and sbbjni64.dll must be located in java.library.path
        // You can also call JNI.initialize("full_path_to_dll") method.
        JNI.initialize("");
		
		
		SBUtils.setLicenseKey("<put the key here>");
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					SMIMECAdESDemo dialog = new SMIMECAdESDemo();
					dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
					dialog.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
		
		
		
	}

}
