

import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.border.TitledBorder;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

import SecureBlackbox.Base.JNI;
import SecureBlackbox.Base.SBUtils;
import SecureBlackbox.Base.TElFileStream;
import SecureBlackbox.PDF.SBPDF;
import SecureBlackbox.PDF.SBPDFSecurity;
import SecureBlackbox.PDF.TElPDFDocument;
import SecureBlackbox.SSLClient.*;
import SecureBlackbox.SSLCommon.*;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.RandomAccessFile;
import java.util.UUID;


@SuppressWarnings("unused")
public class Main extends JDialog {

	private static final long serialVersionUID = 1L;
	private final JPanel contentPanel = new JPanel();
	private JTextField tbSource;
	private JTextField tbDest;

	private TElPDFDocument Document;
	private EncOpDialog frmEncOptions = new EncOpDialog();
	private SigOpDialog frmSigOptions = new SigOpDialog();	
	private boolean FEncrypt;
	private boolean FSign;
	private JTextArea mmStatus;
	
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
   			#error Please pick the evaluation license key from <SecureBlackbox>\LicenseKey.txt file and place it here. If the evaluation key expires, you can request an extension using the form on https://www.eldos.com/sbb/keyreq/
   			SBUtils.setLicenseKey("<put the key here>");
   			JNI.initialize();
    
			Main dialog = new Main();
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog.
	 */
	public Main() {
		addWindowListener(new WindowAdapter() {
			@Override
			public void windowClosing(WindowEvent e) {
				Document.Destroy();
				System.exit(0);
			}
		});			
		setTitle("Secure PDF");
		setBounds(100, 100, 435, 473);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		
		JLabel lblSourcePdf = new JLabel("Source PDF file");
		lblSourcePdf.setBounds(10, 11, 178, 14);
		contentPanel.add(lblSourcePdf);
		
		tbSource = new JTextField();
		tbSource.setBounds(10, 32, 361, 20);
		contentPanel.add(tbSource);
		tbSource.setColumns(10);
		
		JButton btnBrowse = new JButton("...");
		btnBrowse.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				tbSource.setText(getOpenFileName());
			}
		});
		btnBrowse.setBounds(381, 31, 36, 23);
		contentPanel.add(btnBrowse);
		
		JLabel lblDestinationPdfFile = new JLabel("Destination PDF file");
		lblDestinationPdfFile.setBounds(10, 63, 178, 14);
		contentPanel.add(lblDestinationPdfFile);
		
		tbDest = new JTextField();
		tbDest.setColumns(10);
		tbDest.setBounds(10, 84, 361, 20);
		contentPanel.add(tbDest);
		
		JButton button = new JButton("...");
		button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				tbDest.setText(getSaveFileName());
			}
		});
		button.setBounds(381, 83, 36, 23);
		contentPanel.add(button);
		
		JPanel panel = new JPanel();
		panel.setBorder(new TitledBorder(null, "", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		panel.setBounds(10, 115, 407, 270);
		contentPanel.add(panel);
		panel.setLayout(null);
		
		JButton btnSelectEncryptionOptions = new JButton("Select Encryption Options");
		btnSelectEncryptionOptions.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				frmEncOptions.setModal(true);
				frmEncOptions.setVisible(true);
				FEncrypt = (frmEncOptions.isOK());
				UpdateStatus();
			}
		});
		btnSelectEncryptionOptions.setBounds(31, 24, 231, 23);
		panel.add(btnSelectEncryptionOptions);
		
		JButton btnSelectSigningOptions = new JButton("Select Signing Options");
		btnSelectSigningOptions.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				frmSigOptions.setModal(true);
				frmSigOptions.setVisible(true);
				FSign = (frmSigOptions.isOK());
				UpdateStatus();				
			}
		});
		btnSelectSigningOptions.setBounds(31, 58, 231, 23);
		panel.add(btnSelectSigningOptions);
		
		JLabel lblStatus = new JLabel("Status");
		lblStatus.setBounds(10, 106, 46, 14);
		panel.add(lblStatus);
		
		JScrollPane scrollPane = new JScrollPane();
		scrollPane.setBounds(10, 130, 387, 129);
		panel.add(scrollPane);
		
		mmStatus = new JTextArea();
		scrollPane.setViewportView(mmStatus);
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				JButton okButton = new JButton("Process");
				okButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						processClick();
					}
				});
				okButton.setActionCommand("OK");
				buttonPane.add(okButton);
				getRootPane().setDefaultButton(okButton);
			}
			{
				JButton cancelButton = new JButton("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						dispose();
					}
				});
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
			}
		}
		
		init();
	}

	private void init() {
		try
		{
			SBPDF.initialize();
			SBPDFSecurity.initialize();
			
			Document = new TElPDFDocument();
			Document.setOwnActivatedSecurityHandlers(true);
			UpdateStatus();
		} catch(Exception ex) {
			ex.printStackTrace();
		}
	}

	private void UpdateStatus()
	{
		String s = "";
		if (!FEncrypt && !FSign)
			s = "No action will be done.";

		if (FEncrypt)
		{
			s = "Encrypt:\r\n";
			if (frmEncOptions.getPasswordEncryption())
				s = s + "  Using password handler\r\n";
			else
			{
				if (frmEncOptions.getCert() == null)
					s = s + "  WARNING! No certificate selected.\r\n";
				s = s + "  Using public key handler\r\n";
			}

			if (frmEncOptions.getEncryptMetadata())
				s = s + "  Encrypt metadata\r\n";
		}

		if (FSign)
		{
			s = s + "Sign:\r\n";
			if (frmSigOptions.getCert() == null)
				s = s + "  WARNING! No certificate selected.\r\n";
			switch (frmSigOptions.getSignatureType())
			{
				case 0:
				{
					s = s + "  Invisible signature\r\n";
					break;
				}
				case 1: 
				{
					s = s + "  Visible signature\r\n";
					break;
				}
				case 2: 
				{
					s = s + "  MDP signature\r\n";
					break;
				}
			}
			if (frmSigOptions.getAuthor() != "")
				s = s + "  Author: " + frmSigOptions.getAuthor() + "\r\n";
			s = s + "  Reason: " + frmSigOptions.getReason() + "\r\n";
			if (frmSigOptions.getTimestamp())
				s = s + "  Using timestamp\r\n";
		}

		mmStatus.setText(s);
	}

	String getSaveFileName(){
		JFileChooser fc = new JFileChooser();
	    int returnVal = fc.showSaveDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

		return "";
	} 
	
	String getOpenFileName(){
		JFileChooser fc = new JFileChooser();
	    int returnVal = fc.showOpenDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

		return "";
	} 	
	
	protected void processClick() {
		boolean Success = false;
		String TempPath = getTempFileName();

		try 
		{
			// creating a temporary file copy
			copyFile(tbSource.getText(), TempPath, true);
			// opening the temporary file
			TElFileStream F = new TElFileStream(TempPath, "rw", true);
			try 
			{
				Document.open(F);
				try 
				{
					// checking if the document is already encrypted
					if (Document.getEncrypted()) 
					{
						showErrorMessage("The document is encrypted and cannot be signed", "Error");
						return;
					}

					if (FSign)
						frmSigOptions.AddSignature(Document);

					if (FEncrypt)
					{
						frmEncOptions.SetEncryptionHandler(Document);

						if (FSign)
							Document.signAndEncrypt();
						else
							// encrypting the document
							Document.encrypt();
					}

					// allowing to save the document
					Success = true;
				}
				finally 
				{
					// closing the document
					Document.close(Success);
				}
			} 
			finally 
			{
				F.Destroy();
			}
		} 
		catch(Exception ex) 
		{
			showErrorMessage("Error: " + ex.getMessage(), "Error");
			Success = false;
		}

		// if encryption process succeeded, moving the temporary file to the place
		// of destination file
		if (Success) 
		{
			try {
				copyFile(TempPath, tbDest.getText(), true);
				showMessage("Signing/encryption process successfully finished");
			} catch (IOException e) {
				e.printStackTrace();
				showErrorMessage(e.getMessage(), "Error");
			}
		} 
		else 
			showErrorMessage("Signing/encryption failed", "Error");

		// deleting the temporary file
		new File(TempPath).delete();
		if (Success) 
			dispose();
	}
	
	private String getTempFileName() {
		return System.getProperty("java.io.tmpdir") + "/" + UUID.randomUUID().toString();
	}

	void showErrorMessage(String msg, String cap){
		JOptionPane.showMessageDialog(null, msg, cap, JOptionPane.ERROR_MESSAGE);
	}

	void showMessage(String msg){
		JOptionPane.showMessageDialog(null, msg, getTitle(), JOptionPane.INFORMATION_MESSAGE);
	}
	
	private void copyFile(String src, String dest, boolean overwrite) throws IOException {
        RandomAccessFile inputFile = new RandomAccessFile(src, "r");
        RandomAccessFile outputFile = new RandomAccessFile(dest, "rw");
        byte[] buf = new byte[1024];
        int r;
	    
	    if (overwrite)
         outputFile.setLength(0);
	    
        do {
         r = inputFile.read(buf);
         if (r > 0)
          outputFile.write(buf, 0, r);
        } while (r > 0);

        inputFile.close();
        outputFile.close();
	}

}
