

import java.awt.BorderLayout;
	
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JFileChooser;
import javax.swing.JMenuBar;
import javax.swing.JOptionPane;
import javax.swing.JPasswordField;
import javax.swing.JTextField;
import javax.swing.JToolBar;
import javax.swing.JLabel;
import javax.swing.JScrollPane;
import javax.swing.JTable;

import java.io.File;
import java.net.URL;
import java.util.Date;

import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JSeparator;

import org.freepascal.rtl.TObject;

import SecureBlackbox.Base.*;
import SecureBlackbox.SFTPClient.*;
import SecureBlackbox.SFTPCommon.*;
import SecureBlackbox.SSHCommon.*;

import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;


public class Main extends JDialog {
	private static final long serialVersionUID = 1L;
	private final JPanel contentPanel = new JPanel();
	private JTable tableFiles;
	private JMenuItem mntmExit;
	private String currentDir;
	private TElSSHMemoryKeyStorage keyStorage;
	private TElSimpleSFTPClient sftpClient;
	private JTable logTable;
	private JLabel lPath;
	private ProgressDialog dlgProgress;
	java.lang.Thread t;
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			Main dialog = new Main();
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog.
	 */
	public Main() {
		addWindowListener(new WindowAdapter() {
			@Override
			public void windowClosing(WindowEvent e) {
				disconnect();
				System.exit(0);
			}
		});	
		setResizable(false);
		setTitle("ElSimpleSftpClient demo application");
		setBounds(100, 100, 746, 510);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		{
			JToolBar toolBar = new JToolBar();
			toolBar.setBounds(5, 5, 728, 18);
			toolBar.setFloatable(false);
			contentPanel.add(toolBar);
			{
				JButton btnConnect = new JButton("");
				btnConnect.setFocusPainted(false);
				btnConnect.addMouseListener(new MouseAdapter() {
					@Override
					public void mousePressed(MouseEvent e) {
						t = new java.lang.Thread(new Runnable() {
							public void run() {
								connect();
							}
						});
						
						t.start();
					}
				});
				btnConnect.setBorderPainted(false);
				btnConnect.setToolTipText("Connect");
				btnConnect.setIcon(getIcon("connect"));
				toolBar.add(btnConnect);
			}
			{
				JButton btnDisconnect = new JButton("");
				btnDisconnect.setFocusPainted(false);
				btnDisconnect.addMouseListener(new MouseAdapter() {
					@Override
					public void mousePressed(MouseEvent e) {
						t = new java.lang.Thread(new Runnable() {
							public void run() {
								disconnect();								
							}
						});
						
						t.start();
					}
				});				
				btnDisconnect.setBorderPainted(false);
				btnDisconnect.setToolTipText("Disconnect");
				btnDisconnect.setIcon(getIcon("disconnect"));
				toolBar.add(btnDisconnect);
			}
			{
				JButton btnRename = new JButton("");
				btnRename.setFocusPainted(false);
				btnRename.addMouseListener(new MouseAdapter() {
					@Override
					public void mousePressed(MouseEvent e) {
						t = new java.lang.Thread(new Runnable() {
							public void run() {
								rename();								
							}
						});
						
						t.start();
					}
				});						
				btnRename.setBorderPainted(false);
				btnRename.setToolTipText("Rename");				
				btnRename.setIcon(getIcon("rename"));
				toolBar.add(btnRename);
			}
			{
				JButton btnMakedir = new JButton("");
				btnMakedir.setFocusPainted(false);
				btnMakedir.addMouseListener(new MouseAdapter() {
					@Override
					public void mousePressed(MouseEvent e) {
						t = new java.lang.Thread(new Runnable() {
							public void run() {
								makeDir();								
							}
						});
						
						t.start();
					}
				});				
				btnMakedir.setBorderPainted(false);
				btnMakedir.setToolTipText("Create directory");
				btnMakedir.setIcon(getIcon("makedir"));
				toolBar.add(btnMakedir);
			}
			{
				JButton btnDelete = new JButton("");
				btnDelete.setFocusPainted(false);
				btnDelete.addMouseListener(new MouseAdapter() {
					@Override
					public void mousePressed(MouseEvent e) {
						t = new java.lang.Thread(new Runnable() {
							public void run() {
								delete();								
							}
						});
						
						t.start();
					}
				});								
				btnDelete.setBorderPainted(false);
				btnDelete.setToolTipText("Delete");
				btnDelete.setIcon(getIcon("delete"));
				toolBar.add(btnDelete);
			}
			{
				JButton btnDownload = new JButton("");
				btnDownload.setFocusPainted(false);
				btnDownload.addMouseListener(new MouseAdapter() {
					@Override
					public void mousePressed(MouseEvent e) {
						t = new java.lang.Thread(new Runnable() {
							
							public void run() {						
								download();
							}
						});
						
						t.start();
					}
				});								
				btnDownload.setBorderPainted(false);
				btnDownload.setToolTipText("Download");
				btnDownload.setIcon(getIcon("download"));
				toolBar.add(btnDownload);
			}
			{
				JButton btnUpload = new JButton("");
				btnUpload.setFocusPainted(false);
				btnUpload.addMouseListener(new MouseAdapter() {
					@Override
					public void mousePressed(MouseEvent e) {
						t = new java.lang.Thread(new Runnable() {
							public void run() {
								upload();								
							}
						});
						
						t.start();
					}
				});								
				btnUpload.setBorderPainted(false);
				btnUpload.setToolTipText("Upload");
				btnUpload.setIcon(getIcon("upload"));
				toolBar.add(btnUpload);
			}
			{
				JButton btnRefresh = new JButton("");
				btnRefresh.setFocusPainted(false);
				btnRefresh.addMouseListener(new MouseAdapter() {
					@Override
					public void mousePressed(MouseEvent e) {
						refreshData();
					}
				});								
				btnRefresh.setBorderPainted(false);
				btnRefresh.setToolTipText("Refresh");
				btnRefresh.setIcon(getIcon("refresh"));
				toolBar.add(btnRefresh);
			}
		}
		{
			JScrollPane scrollPane = new JScrollPane();
			scrollPane.setBounds(5, 31, 728, 294);
			contentPanel.add(scrollPane);
			{
				tableFiles = new JTable(new FilesTableModel());
				tableFiles.addMouseListener(new MouseAdapter(){
					public void mouseClicked(MouseEvent e){
						if (e.getClickCount() == 2){
							changeDir();
						}
					}
				} );
				tableFiles.addKeyListener(new KeyAdapter() {
					@Override
					public void keyPressed(KeyEvent e) {
						if (e.getKeyCode() == KeyEvent.VK_ENTER)
							changeDir();
					}
				});
				tableFiles.setFillsViewportHeight(true);
				scrollPane.setViewportView(tableFiles);
			}
		}
		{
			scrollLog = new JScrollPane();
			scrollLog.setBounds(5, 350, 728, 107);
			contentPanel.add(scrollLog);
			{
				logTable = new JTable(new LogTableModel());
				logTable.setFillsViewportHeight(true);
				tableFiles.setFillsViewportHeight(true);
				scrollLog.setViewportView(logTable);
			}
		}		
		
		lPath = new JLabel("Ready");
		lPath.setBounds(6, 331, 723, 14);
		contentPanel.add(lPath);
		{
			JMenuBar menuBar = new JMenuBar();
			setJMenuBar(menuBar);
			{
				JMenu mnConnection = new JMenu("Connection");
				menuBar.add(mnConnection);
				{
					JMenuItem mntmConnect = new JMenuItem("Connect");
					mntmConnect.addMouseListener(new MouseAdapter() {
						@Override
						public void mousePressed(MouseEvent e) {
							connect();
						}
					});
					mnConnection.add(mntmConnect);
				}
				{
					JMenuItem mntmDisconnect = new JMenuItem("Disconnect");
					mntmDisconnect.addMouseListener(new MouseAdapter() {
						@Override
						public void mousePressed(MouseEvent e) {
							t = new java.lang.Thread(new Runnable() {
								public void run() {
									disconnect();								
								}
							});
							
							t.start();
						}
					});
					mnConnection.add(mntmDisconnect);
				}
				{
					JSeparator separator = new JSeparator();
					mnConnection.add(separator);
				}
				{
					mntmExit = new JMenuItem("Exit");
					mntmExit.addMouseListener(new MouseAdapter() {
						@Override
						public void mousePressed(MouseEvent e) {
							disconnect();
							dispose();
						}
					});
					mnConnection.add(mntmExit);
				}
			}
			{
				JMenu mnHelp = new JMenu("Help");
				menuBar.add(mnHelp);
				{
					JMenuItem mntmAbout = new JMenuItem("About");
					mntmAbout.addMouseListener(new MouseAdapter() {
						@Override
						public void mousePressed(MouseEvent e) {
							showAbout();
						}
					});
					mnHelp.add(mntmAbout);
				}
			}
		}
		init();
	}

	protected void showAbout() {
		AboutDialog dlg = new AboutDialog();
		dlg.setModal(true);
		dlg.setVisible(true);
	}

	private Icon getIcon(String name) {
		URL resPath = getClass().getResource(name + ".ico");
		if (resPath == null) return new ImageIcon();
		return new ImageIcon(resPath);
	}
	
	private void init()
	{
		//#error Please pick the evaluation license key from <SecureBlackbox>\LicenseKey.txt file and place it here. If the evaluation key expires, you can request an extension using the form on https://www.eldos.com/sbb/keyreq/
		SBUtils.setLicenseKey("<put the key here>");

		sftpClient = new TElSimpleSFTPClient();
		
		sftpClient.setClientHostname("");
		sftpClient.setClientUsername("");
		sftpClient.setCompressionLevel(6);
		sftpClient.setForceCompression(false);
		sftpClient.setPassword("");
		sftpClient.setSoftwareName("EldoS.SFTPBlackbox.8");
		sftpClient.setUsername("");
		sftpClient.setVersions((short)(28));
		keyStorage = new TElSSHMemoryKeyStorage();
		sftpClient.setKeyStorage(keyStorage);
		initEvents();
	}
	
	private void connect()
	{
		ConnDialog dlg = new ConnDialog();
		if (sftpClient.getActive()) 
		{
			showMessage("SFTP Connection Status", "Already connected");
			return;
		}
		dlg.setModal(true);
		dlg.setVisible(true);
		
		if (dlg.isOK()) 
		{
			sftpClient.setUsername(dlg.getUsername());
			sftpClient.setPassword(dlg.getPassword());
			sftpClient.setAddress(dlg.getHost());
			sftpClient.setPort(22);
			int i = sftpClient.getAddress().indexOf(':');
			if (i > 0)
			{
				sftpClient.setPort(Integer.parseInt(sftpClient.getAddress().substring(i + 1)));
				sftpClient.setAddress(sftpClient.getAddress().substring(0, i));
			}

			keyStorage.clear();
			TElSSHKey Key = new TElSSHKey();
            sftpClient.setAuthenticationTypes(SBSSHConstants.SSH_AUTH_TYPE_PASSWORD | SBSSHConstants.SSH_AUTH_TYPE_KEYBOARD);


			if (dlg.getPrivateKey().compareTo("") != 0) 
			{
				int err = Key.loadPrivateKey(dlg.getPrivateKey(), dlg.getPrivateKeyPassword());
				if (err == 0)
				{
					keyStorage.add(Key);
					sftpClient.setAuthenticationTypes(sftpClient.getAuthenticationTypes() | SBSSHConstants.SSH_AUTH_TYPE_PUBLICKEY);
				}
				else
				{
					sftpClient.setAuthenticationTypes(sftpClient.getAuthenticationTypes() & (~SBSSHConstants.SSH_AUTH_TYPE_PUBLICKEY));
					log("Private key file could not be loaded due to error "  + err, true);
				}
			}
			else
			{
				sftpClient.setAuthenticationTypes(sftpClient.getAuthenticationTypes() & (~SBSSHConstants.SSH_AUTH_TYPE_PUBLICKEY));
			}
							
			log("Connecting to " + dlg.getHost(), false);
			try
			{
				sftpClient.open();
			}
			catch (Exception e)
			{
				log("Connection failed due to exception: " + e.getMessage(), true);
				log("If you have ensured that all connection parameters are correct and you still can't connect,", true);
				log("please contact EldoS support as described on http://www.eldos.com/sbb/support-tech.php", true);
				log("Remember to provide details about the error that happened.", true);
				if (sftpClient.getServerSoftwareName().length() > 0)
				{
					log("Server software identified itself as: " + sftpClient.getServerSoftwareName(), true);
				}
				try
				{
					sftpClient.close(true);
				}
				catch(Exception ex)
				{
				}
				return;
			}
			log("SFTP connection established", false);
			currentDir = ".";
			refreshData();
		};
	}

	static void showMessage(String caption, String msg) {
		JOptionPane.showMessageDialog(null, msg, caption, JOptionPane.INFORMATION_MESSAGE);
	}	

	private void disconnect()
	{
		log("Disconnecting", false);
		if (sftpClient.getActive()) 
		{
			sftpClient.close(true);
			clearFileList();
		}
	}

	private void rename()
	{
		String NewName;
		if (sftpClient.getActive()) 
		{
			if ((tableFiles.getSelectedRowCount() > 0))
			{
				FilesTableModel model = (FilesTableModel) tableFiles.getModel();
				TElSftpFileInfo info = model.getSelectedRowTag(tableFiles.getSelectedRow());
								
				NewName = inputDialog("Please enter the new name for " + info.getName());
				if (NewName.length() > 0) 
				{
					log("Renaming " + info.getName() + " to " + NewName, false);
					try 
					{
						sftpClient.renameFile(absPath(info.getName()),
							absPath(NewName));
					} 
					catch (Exception ex) 
					{
						log("Failed to rename file '" + info.getName() + "' to '" +
							NewName + "', " + ex.getMessage(), true);
					}
					refreshData();
				}
			}
		}
	}

	private void makeDir()
	{
		if (sftpClient.getActive()) 
		{
			String DirName = inputDialog("Please specify the name for new directory");
			if (DirName.length() > 0) 
			{
				log("Creating directory " + DirName, false);
				try 
				{
					sftpClient.makeDirectory(absPath(DirName), null);
				} 
				catch(Exception ex) 
				{
					log("Failed to create directory '" + DirName + "', " + ex.getMessage(), true);
				}
				refreshData();
			}
		}
	}
	
	private String inputDialog(String msg) {
		JTextField jpf = new JTextField();
		JOptionPane.showConfirmDialog(this, jpf, msg, JOptionPane.OK_CANCEL_OPTION);
		return jpf.getText();
	}
	
	private boolean prompt(String cap, boolean echo, TSBString response) {
		int result;
		if (echo)
		{
			JTextField jpf = new JTextField();
			result = JOptionPane.showConfirmDialog(null, jpf, cap, JOptionPane.OK_CANCEL_OPTION);
			response.value = jpf.getText();
		} else {
			JPasswordField jpf = new JPasswordField();
			result = JOptionPane.showConfirmDialog(null, jpf, cap, JOptionPane.OK_CANCEL_OPTION);
			response.value = new String(jpf.getPassword());				
		}

		return (result == 0);
	}
	
	private void delete()
	{
		TElSftpFileInfo info;
		if (sftpClient.getActive()) 
		{
			if ((sftpClient.getActive()) && (tableFiles.getSelectedRowCount() > 0))
			{
				FilesTableModel model = (FilesTableModel) tableFiles.getModel();
				info = model.getSelectedRowTag(tableFiles.getSelectedRow());
				
				if (showConfirmMessage("Please confirm that you want to delete " + 
					info.getName(), "Delete item")) 
				{
					log("Removing item " + info.getName(), false);
					try 
					{
						if (info.getAttributes().getDirectory()) 
						{
							sftpClient.removeDirectory(absPath(info.getName()));
						} 
						else 
						{
							sftpClient.removeFile(absPath(info.getName()));
						}
					} 
					catch(Exception ex) 
					{
						log("Failed to delete " + info.getName() + ", " + ex.getMessage(), true);
					}
					refreshData();
				}
			}
		}
	}

	private boolean showConfirmMessage(String msg, String cap) {
		return (JOptionPane.showConfirmDialog(this, msg, cap, JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION);
	}

	private void download()
	{
		TElSftpFileInfo info;
		dlgProgress = new ProgressDialog();
		
		if ((sftpClient.getActive()) && (tableFiles.getSelectedRowCount() > 0))
		{
			FilesTableModel model = (FilesTableModel) tableFiles.getModel();
			info = model.getSelectedRowTag(tableFiles.getSelectedRow());

			String fileName = getSaveFileName();
			if (fileName.compareTo("") != 0) 
			{
				dlgProgress.setCaptionText("Download");
				dlgProgress.setSourceFilename(absPath(info.getName()));
				dlgProgress.setDestFilename(fileName);
				dlgProgress.setProgressText("0 / " + info.getAttributes().getSize());
				dlgProgress.setProgressValue(0);
				dlgProgress.setVisible(true);
				try 
				{
					sftpClient.downloadFile(absPath(info.getName()), fileName);
				} 
				catch(Exception ex) 
				{
					log("Error during download: " + ex.getMessage(), true);
				}
				dlgProgress.setVisible(false);
				dlgProgress.dispose();
				dlgProgress = null;
				log("Download finished", false);
			}				
		}
	}

	String getSaveFileName(){
		JFileChooser fc = new JFileChooser();
	    int returnVal = fc.showSaveDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	} 
	
	String getOpenFileName(){
		JFileChooser fc = new JFileChooser();
	    int returnVal = fc.showOpenDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	} 
	
	private void upload()
	{
		long size;
		String shortName;
		String fileName = getOpenFileName();
		dlgProgress = new ProgressDialog();

		if (sftpClient.getActive()) 
		{
			if (fileName.compareTo("") != 0) 
			{
				log("Uploading file " + fileName, false);
				File file = new File(fileName);
				shortName = file.getName();
				dlgProgress.setCaptionText("Upload");
				dlgProgress.setSourceFilename(fileName);
				dlgProgress.setDestFilename(absPath(shortName));
				size = file.length();
				dlgProgress.setProgressText("0 / " + size);
				dlgProgress.setProgressValue(0);
				dlgProgress.setVisible(true);
				try 
				{
					String remoteName = absPath(shortName);
					sftpClient.uploadFile(fileName, remoteName);
					try
					{
						// now adjust the attributes of the uploaded file
						TElSftpFileAttributes Attrs = new TElSftpFileAttributes();
						Attrs.setCTime(new Date());
						Attrs.setMTime(Attrs.getCTime());
						Attrs.setATime(Attrs.getCTime());
						Attrs.setCATime(Attrs.getCTime());

						Attrs.setIncludedAttributes(SBSftpCommon.saATime | SBSftpCommon.saMTime | SBSftpCommon.saCTime | SBSftpCommon.saCATime);
						sftpClient.setAttributes(remoteName, Attrs);
					}
					catch (Exception ex)
					{
						log("Error when trying to change the attributes of the uploaded file: " + ex.getMessage(), true);
					}
				}
				catch (Exception ex)
				{
					ex.printStackTrace();
					log("Error during upload: " + ex.getMessage(), true);
				}
				
				
				dlgProgress.setVisible(false);
				dlgProgress.dispose();
				log("Upload finished", false);
				refreshData();
			}
		}
	}

	private void refreshData()
	{
		ArrayList dirList = new ArrayList();
		TElSftpFileInfo info;
		
		FilesTableModel model = (FilesTableModel) tableFiles.getModel();
		
		clearFileList();
		
		if (!sftpClient.getActive()) 
		{
			return; 
		}
		try 
		{
			currentDir = sftpClient.requestAbsolutePath(currentDir);
		} 
		catch (Exception ex) 
		{
			currentDir = ".";
		}
		lPath.setText(currentDir);
		
		log("Retrieving file list", false);
		
		try 
		{
			sftpClient.listDirectory(currentDir, dirList);
			FileInfoComparer comparer = new FileInfoComparer();
			dirList.sort(comparer);
			for(int i = 0; i < dirList.size(); i++) 
			{
				info = new TElSftpFileInfo();
				((TElSftpFileInfo)dirList.get(i)).copyTo(info);
				
				model.addItem(info);
			}
		} 
		catch(Exception ex) 
		{
			log("Failed to retrieve file list" + ex.getMessage(), true);
			return;
		}
	}

	public String absPath(String strFileName)
	{
		String strResult = "";
		
		char lastSymbol = currentDir.charAt(currentDir.length() - 1);
		
		if ((currentDir.length() == 0) ||
			(lastSymbol != '\\' && lastSymbol != '/'))
		{
			strResult = currentDir + '/' + strFileName;
		}
		else strResult = currentDir + strFileName;

		return strResult;
	}

	
	private void changeDir()
	{
		TElSftpFileInfo info;
		byte[] dirHandle;
		if ((sftpClient.getActive()) && (tableFiles.getSelectedRowCount() > 0)) 
		{
			FilesTableModel model = (FilesTableModel) tableFiles.getModel();
			info = model.getSelectedRowTag(tableFiles.getSelectedRow());
			if (info.getAttributes().getDirectory()) 
			{
				log("Changing directory to " + info.getName(), false);
				try 
				{
					dirHandle = sftpClient.openDirectory(absPath(info.getName()));
				} 
				catch(Exception ex) 
				{
					log("Unable to change directory: " + ex.getMessage(), true);
					return;
				}
				try 
				{
					sftpClient.closeHandle(dirHandle);
					currentDir = sftpClient.requestAbsolutePath(absPath(info.getName()));
				} 
				catch(Exception ex) 
				{
					log("Unexpected error: " + ex.getMessage(), true);
				}
				refreshData();
			}
		}
	}

	private void log(String msg, boolean isError) 
	{
		LogTableModel model = (LogTableModel)logTable.getModel();
		model.addRow(new Date(), msg, isError ? "Eror" : "Info");
		scrollToEndTable(logTable);
	}

	private void scrollToEndTable(JTable tbl) {
		tbl.scrollRectToVisible(tbl.getCellRect(tbl.getRowCount() - 1, tbl.getColumnCount(), true));		
	}

	private void clearFileList()
	{
		((FilesTableModel)tableFiles.getModel()).clear();
	}
		
	private void initEvents() {
		sftpClient.setOnKeyValidate(new TSSHKeyValidateEvent(onKeyValidate));
		sftpClient.setOnAuthenticationSuccess(new TNotifyEvent(onAuthenticationSuccess));
		sftpClient.setOnAuthenticationKeyboard(new TSSHAuthenticationKeyboardEvent(onAuthenticationKeyboard));
		sftpClient.setOnCloseConnection(new TSSHCloseConnectionEvent(onCloseConnection));
		sftpClient.setOnError(new TSSHErrorEvent(onError));
		sftpClient.setMessageLoop(new TSBSftpMessageLoopEvent(messageLoop));
		sftpClient.setOnAuthenticationFailed(new TSSHAuthenticationFailedEvent(onAuthenticationFailed));
		sftpClient.setOnProgress(new TSBProgressEvent(onProgress));
	}

	TSBProgressEvent.Callback onProgress = new TSBProgressEvent.Callback() {
		
		public void tsbProgressEventCallback(TObject sender, long total, long current, TSBBoolean cancel) {
			dlgProgress.setProgressValue((int)(current * 100 / total));
			dlgProgress.setProgressText(current + " / " + total);
			cancel.value = false;
		}
	};
	
	TSSHAuthenticationFailedEvent.Callback onAuthenticationFailed = new TSSHAuthenticationFailedEvent.Callback() {
		
		public void tsshAuthenticationFailedEventCallback(TObject sender, int authType) {
			log("Authentication type [" + authType + "] failed", true);			
		}
	};
	
	TSBSftpMessageLoopEvent.Callback messageLoop = new TSBSftpMessageLoopEvent.Callback() {
		
		public boolean tsbSftpMessageLoopEventCallback() {
			return true;
		}
	};
	
	TSSHErrorEvent.Callback onError = new TSSHErrorEvent.Callback() {
		
		public void tsshErrorEventCallback(TObject sender, int errorCode) {
			log("Error " + errorCode, true);
		}
	};
	
	TSSHCloseConnectionEvent.Callback onCloseConnection = new TSSHCloseConnectionEvent.Callback() {
		
		public void tsshCloseConnectionEventCallback(TObject sender) {
			log("SFTP connection closed", false);
		}
	};
	
	TSSHAuthenticationKeyboardEvent.Callback onAuthenticationKeyboard = new TSSHAuthenticationKeyboardEvent.Callback() {
		
		public void tsshAuthenticationKeyboardEventCallback(TObject sender,
				TElStringList prompts, boolean[] echo, TElStringList responses) {
			responses.clear();
			for (int i = 0; i < prompts.getCount(); i++)
			{
				TSBString response = new TSBString();				
				if (prompt((String) prompts.get(i), echo[i], response))
					responses.add(response.value);
				else
					responses.add("");
			}
		}
	};
	
	TNotifyEvent.Callback onAuthenticationSuccess = new TNotifyEvent.Callback() {
		
		public void tNotifyEventCallback(TObject sender) {
			log("Authentication succeeded", false);
		}
	}; 
	
	TSSHKeyValidateEvent.Callback onKeyValidate = new TSSHKeyValidateEvent.Callback() {
		
		public void tsshKeyValidateEventCallback(TObject sender, TElSSHKey serverKey, TSBBoolean accept) {
			log("Server key [" + SBUtils.digestToStr128(serverKey.getFingerprintMD5(), true) + "] received", false);
			accept.value = true;
		}
	};
	private JScrollPane scrollLog;
}
