import SecureBlackbox.SFTPCommon.*;


public class FilesDataRow {
	public String Name;
	public String Size;
	public String Permissions;
	public TElSftpFileInfo Tag;

	public FilesDataRow(TElSftpFileInfo info){
		Tag = info;
		Name = info.getName();
		Size = info.getAttributes().getSize() + "";
		Permissions = WritePermissions(info.getAttributes());
	}
	
	private String WritePermissions(TElSftpFileAttributes attributes)
	{
		StringBuilder sb = new StringBuilder();
		if (attributes.getDirectory())
			sb.append('d');
		if (attributes.getUserRead())
			sb.append('r');
		else
			sb.append('-');
		if (attributes.getUserWrite())
			sb.append('w');
		else
			sb.append('-');
		if (attributes.getUserExecute())
			sb.append('x');
		else
			sb.append('-');
		if (attributes.getGroupRead())
			sb.append('r');
		else
			sb.append('-');
		if (attributes.getGroupWrite())
			sb.append('w');
		else
			sb.append('-');
		if (attributes.getGroupExecute())
			sb.append('x');
		else
			sb.append('-');
		if (attributes.getOtherRead())
			sb.append('r');
		else
			sb.append('-');
		if (attributes.getOtherWrite())
			sb.append('w');
		else
			sb.append('-');
		if (attributes.getOtherExecute())
			sb.append('x');
		else
			sb.append('-');

		return sb.toString();
	}	
}
