

import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JSeparator;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import javax.swing.JToolBar;
import java.awt.BorderLayout;
import javax.swing.JButton;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.util.Date;

import javax.swing.JTextArea;

import SecureBlackbox.Base.SBUtils;
import SecureBlackbox.Base.TElMemoryCertStorage;
import SecureBlackbox.Base.TElX509Certificate;
import SecureBlackbox.Base.TElX509CertificateValidator;
import SecureBlackbox.Base.TElX509CertificateValidatorResult;
import SecureBlackbox.Base.TSBBoolean;
import SecureBlackbox.Base.TSBCertificateValidity;
import SecureBlackbox.Base.TSBHostRole;
import SecureBlackbox.Base.TSBInteger;
import SecureBlackbox.SSLClient.TElSimpleSSLClient;
import SecureBlackbox.SSLClient.TSBCertificateNeededExEvent;
import SecureBlackbox.SSLCommon.TSBCloseReason;
import SecureBlackbox.SSLCommon.SBSSLConstants;
import SecureBlackbox.SSLCommon.TSBCertificateValidateEvent;
import SecureBlackbox.SSLCommon.TSBCloseConnectionEvent;

import javax.swing.JLabel;

import org.freepascal.rtl.TObject;
import SecureBlackbox.HTTPClient.*;
import javax.swing.ImageIcon;

public class Main {
	
	TElX509CertificateValidator CertificateValidator;
	private JFrame frmSslclientdemo;
	private OptionsDialog odlg;
	private JTextArea tbData;

	final int recvBufferSize = 16384;
	private boolean bUseSSL2;
	private boolean bUseSSL3;
	private boolean bUseTLS1;
	private boolean bUseTLS11;
	private boolean bUseTLS12;
	private boolean bUseOnlyExportable;
	private boolean bAllowAnonymous;
	private boolean bSSLEnabled;
    private boolean bStrictCertValidation;

	private TElMemoryCertStorage clientCerts;
	private String host;
	private int port;

	private int certIndex;
	private TElSimpleSSLClient SecureClient;
	private JLabel lStatus;
	
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					Main window = new Main();
					window.frmSslclientdemo.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the application.
	 */
	public Main() {
		initialize();
	}

	/**
	 * Initialize the contents of the frame.
	 */
	private void initialize() {
		init();
		
		frmSslclientdemo = new JFrame();
		frmSslclientdemo.setTitle("SSLClientDemo");
		frmSslclientdemo.setBounds(100, 100, 526, 401);
		frmSslclientdemo.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		JMenuBar menuBar = new JMenuBar();
		frmSslclientdemo.setJMenuBar(menuBar);
		
		JMenu mnConnection = new JMenu("Connection");
		menuBar.add(mnConnection);
		
		JMenuItem mntmConnect = new JMenuItem("Connect");
		mntmConnect.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent arg0) {
				connect();
			}
		});
		mnConnection.add(mntmConnect);
		
		JMenuItem mntmDisconnect = new JMenuItem("Disconnect");
		mntmDisconnect.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				disconnect();
			}
		});
		mnConnection.add(mntmDisconnect);
		
		JSeparator separator = new JSeparator();
		mnConnection.add(separator);
		
		JMenuItem mntmExit = new JMenuItem("Exit");
		mntmExit.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				frmSslclientdemo.dispose();
			}
		});
		mnConnection.add(mntmExit);
		
		JMenu mnTools = new JMenu("Tools");
		menuBar.add(mnTools);
		
		JMenuItem mntmSslOptions = new JMenuItem("SSL Options");
		mntmSslOptions.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				options();
			}
		});
		mnTools.add(mntmSslOptions);
		
		JMenu mnHelp = new JMenu("Help");
		menuBar.add(mnHelp);
		
		JMenuItem mntmAbout = new JMenuItem("About");
		mntmAbout.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				help();
			}
		});
		mnHelp.add(mntmAbout);
		
		JToolBar toolBar = new JToolBar();
		toolBar.setFloatable(false);
		frmSslclientdemo.getContentPane().add(toolBar, BorderLayout.NORTH);
		
		JButton btnConnect = new JButton("");
		btnConnect.setToolTipText("Connect");
		btnConnect.setIcon(new ImageIcon(Main.class.getResource("/javax/swing/plaf/metal/icons/ocean/computer.gif")));
		btnConnect.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				connect();
			}
		});
		toolBar.add(btnConnect);
		
		JButton btnDisconnect = new JButton("");
		btnDisconnect.setToolTipText("Disconnect");
		btnDisconnect.setIcon(new ImageIcon(Main.class.getResource("/javax/swing/plaf/metal/icons/ocean/close.gif")));
		btnDisconnect.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				disconnect();
			}
		});
		toolBar.add(btnDisconnect);
		
		JButton btnOptions = new JButton("");
		btnOptions.setToolTipText("Options");
		btnOptions.setIcon(new ImageIcon(Main.class.getResource("/javax/swing/plaf/metal/icons/ocean/homeFolder.gif")));
		btnOptions.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				options();
			}
		});
		toolBar.add(btnOptions);
		
		JSeparator separator_1 = new JSeparator();
		toolBar.add(separator_1);
		
		tbData = new JTextArea();
		frmSslclientdemo.getContentPane().add(tbData, BorderLayout.CENTER);
		
		lStatus = new JLabel("Ready");
		frmSslclientdemo.getContentPane().add(lStatus, BorderLayout.SOUTH);
	}

	protected void help() {
        AboutDialog dlg = new AboutDialog();
        dlg.setModal(true);
		dlg.setVisible(true);		
	}

	protected void options() {
		putSSLOptionsToDialog();
		odlg.setModal(true);
		odlg.setVisible(true);
		
		if (odlg.isOk())
			getSSLOptionsFromDialog();
	}

	protected void disconnect() {
		SecureClient.close(true);
		status("");
	}

	protected void connect() {
		ConnectionDialog dlg = new ConnectionDialog();
		
		dlg.setModal(true);
		dlg.setVisible(true);
		
		if (dlg.isOk()) 
		{
			setupSSLOptions();
			tbData.setText("");
			host = dlg.getHost();
			port = Integer.parseInt(dlg.getPort());
			bSSLEnabled = dlg.getSSLEnabled();
			status("Resolving host " + host + "...");
			status("Connecting to " + host + "...");
			certIndex = -1;
			for(int i = 0; i < clientCerts.getChainCount(); i++) {
				int index = clientCerts.getChain(i);
				if (clientCerts.getCertificate(index).getPrivateKeyExists()) 
				{
                    certIndex = index;
					break;
				}
			} 
			
			SecureClient.setAddress(host);
			SecureClient.setPort(port);
			SecureClient.setEnabled(bSSLEnabled);
			java.lang.Thread t = new java.lang.Thread(new Runnable() {
				public void run() {
					doRequest();
				}
			});
			
			t.start();
		}		
	}

	private void doRequest() {
		String s;
		byte[] Buffer;
		SecureClient.open();
		if (SecureClient.getActive())
		{
			status("Sending request ...");
			String request = "GET / HTTP/1.1\nHost:" + host + "\nUser-Agent: EldoS SSLBlackbox (Java edition)\nConnection: close\n\n";
			Buffer = SBUtils.bytesOfString(request);
			SecureClient.sendData(Buffer, 0, Buffer.length);
		}
		
		TSBInteger ToRead = new TSBInteger();
		while (SecureClient.getActive())
		{
			try
			{
				ToRead.value = 16384;
				Buffer = new byte[ToRead.value];		
				SecureClient.receiveData(Buffer, ToRead, false);
				s = SBUtils.stringOfBytes(Buffer);
				tbData.setText(tbData.getText() + s);
			}
			catch (Exception ex)
			{
				break;
			}
		}
		disconnect();
	}

	private void status(String val) {
		lStatus.setText(val);
	}

	private void setupSSLOptions() {
		SecureClient.setVersions((short)0);
		
		if (bUseSSL2) 
		{
			SecureClient.setVersions((short) ((byte) SecureClient.getVersions() | (byte)SBSSLConstants.sbSSL2));
		}
		if (bUseSSL3) 
		{
			SecureClient.setVersions((short) ((byte) SecureClient.getVersions() | (byte)SBSSLConstants.sbSSL3));
		}
		if (bUseTLS1) 
		{
			SecureClient.setVersions((short) ((byte) SecureClient.getVersions() | (byte)SBSSLConstants.sbTLS1));
		}
		if (bUseTLS11) 
		{
			SecureClient.setVersions((short) ((byte) SecureClient.getVersions() | (byte)SBSSLConstants.sbTLS11));
		}
		if (bUseTLS12) 
		{
			SecureClient.setVersions((short) ((byte) SecureClient.getVersions() | (byte)SBSSLConstants.sbTLS12));
		}
		
		for(int i = SBSSLConstants.SB_SUITE_FIRST; i <= SBSSLConstants.SB_SUITE_LAST; i++) 
		{
            SecureClient.setCipherSuite((short)i, false);
		}
		
		if (bUseOnlyExportable) 
		{
			SecureClient.setCipherSuite(SBSSLConstants.SB_SUITE_RSA_DES_SHA_EXPORT, true);
			SecureClient.setCipherSuite(SBSSLConstants.SB_SUITE_RSA_RC2_MD5_EXPORT, true);
			SecureClient.setCipherSuite(SBSSLConstants.SB_SUITE_RSA_RC4_MD5_EXPORT, true);
			SecureClient.setCipherSuite(SBSSLConstants.SB_SUITE_DHE_RSA_DES_SHA_EXPORT, true);
			SecureClient.setCipherSuite(SBSSLConstants.SB_SUITE_DH_DSS_DES_SHA_EXPORT, true);
			SecureClient.setCipherSuite(SBSSLConstants.SB_SUITE_DH_RSA_DES_SHA_EXPORT, true);
			SecureClient.setCipherSuite(SBSSLConstants.SB_SUITE_DHE_DSS_DES_SHA_EXPORT, true);
			if (bAllowAnonymous) 
			{
				SecureClient.setCipherSuite(SBSSLConstants.SB_SUITE_DH_ANON_DES_SHA_EXPORT, true);
				SecureClient.setCipherSuite(SBSSLConstants.SB_SUITE_DH_ANON_RC4_MD5_EXPORT, true);
			}
		} 
		else 
		{
			for(int i = SBSSLConstants.SB_SUITE_FIRST; i <= SBSSLConstants.SB_SUITE_LAST; i++) 
			{
				SecureClient.setCipherSuite((short)i, true);
			}
			if (!bAllowAnonymous) 
			{
				SecureClient.setCipherSuite(SBSSLConstants.SB_SUITE_DH_ANON_3DES_SHA, false);
				SecureClient.setCipherSuite(SBSSLConstants.SB_SUITE_DH_ANON_AES128_SHA, false);
				SecureClient.setCipherSuite(SBSSLConstants.SB_SUITE_DH_ANON_AES256_SHA, false);
				SecureClient.setCipherSuite(SBSSLConstants.SB_SUITE_DH_ANON_DES_SHA, false);
				SecureClient.setCipherSuite(SBSSLConstants.SB_SUITE_DH_ANON_DES_SHA_EXPORT, false);
				SecureClient.setCipherSuite(SBSSLConstants.SB_SUITE_DH_ANON_RC4_MD5, false);
				SecureClient.setCipherSuite(SBSSLConstants.SB_SUITE_DH_ANON_RC4_MD5_EXPORT, false);
			}
		}
	}

	private void putSSLOptionsToDialog()
	{
		odlg.setCertificates(clientCerts);
		odlg.setSSL2(bUseSSL2);
		odlg.setSSL3(bUseSSL3);
		odlg.setTLS1(bUseTLS1);
		odlg.setTLS11(bUseTLS11);
		odlg.setTLS12(bUseTLS12);
		odlg.setAllowAnon(bAllowAnonymous);
		odlg.setExportableOnly(bUseOnlyExportable);
        odlg.setStrictCertValidation(bStrictCertValidation);
	}

	private void getSSLOptionsFromDialog()
	{
		odlg.getCertificates(clientCerts);
		bUseSSL2 = odlg.getSSL2();
		bUseSSL3 = odlg.getSSL3();
		bUseTLS1 = odlg.getTLS1();
		bUseTLS11 = odlg.getTLS11();
		bUseTLS12 = odlg.getTLS12();
		bAllowAnonymous = odlg.getAllowAnon();
		bUseOnlyExportable = odlg.getExportableOnly();
        bStrictCertValidation = odlg.getStrictCertValidation();
	}
	
	protected void init()
	{
		bUseSSL2 = false;
		bUseSSL3 = false;
		bUseTLS1 = true;
		bUseTLS11 = true;
		bUseTLS12 = true;
		bUseOnlyExportable = false;
		bAllowAnonymous = false;
        bStrictCertValidation = false;
        clientCerts = new TElMemoryCertStorage();
		odlg = new OptionsDialog();
		SecureClient = new TElSimpleSSLClient();        
		
		#error Please pick the evaluation license key from <SecureBlackbox>\LicenseKey.txt file and place it here. If the evaluation key expires, you can request an extension using the form on https://www.eldos.com/sbb/keyreq/
		SBUtils.setLicenseKey("<put the key here>");
		
		// The following lines are required for HTTP retrieval of CRLs and OCSP in TElX509CertificateValidator to work
		SBHTTPCRL.registerHTTPCRLRetrieverFactory();
		SBHTTPOCSPClient.registerHTTPOCSPClientFactory();
		events();
	}
	
	protected void events() {
		SecureClient.setOnCertificateNeededEx(new TSBCertificateNeededExEvent(certNeed));
		SecureClient.setOnCertificateValidate(new TSBCertificateValidateEvent(certValid));
		SecureClient.setOnCloseConnection(new TSBCloseConnectionEvent(closeConn));
	}
	
	TSBCertificateNeededExEvent.Callback certNeed = new TSBCertificateNeededExEvent.Callback() {		
		public TElX509Certificate tsbCertificateNeededExEventCallback(TObject obj) {
			if (certIndex >= 0) 
			{
				TElX509Certificate Certificate = clientCerts.getCertificate(certIndex);
				certIndex = clientCerts.getIssuerCertificate(Certificate);
				return Certificate;
			} 
			return null;
		}
	};
	
	TSBCertificateValidateEvent.Callback certValid = new TSBCertificateValidateEvent.Callback() {		
		public void tsbCertificateValidateEventCallback(TObject obj, TElX509Certificate Certificate, TSBBoolean accept) {
			status("Certificate received");
			if ((bStrictCertValidation) && ((Certificate.getChain() == null) || (Certificate.getChain().getCertificate(0) == Certificate)))
			{
				TElX509CertificateValidatorResult vres = new TElX509CertificateValidatorResult();
				CertificateValidator.validateForSSL(Certificate, SecureClient.getRemoteHost(), SecureClient.getRemoteIP(), TSBHostRole.hrServer, null, false, new Date(), vres);				
				accept.value = (vres.Validity == TSBCertificateValidity.cvOk);
			}
			else
				accept.value = true;
			
		}
	};
	
	TSBCloseConnectionEvent.Callback closeConn = new TSBCloseConnectionEvent.Callback() {
		@Override
		public void tsbCloseConnectionEventCallback(TObject arg0, SecureBlackbox.SSLCommon.TSBCloseReason arg1) {
			status("SSL connection closed");	
			
		}
	};
}
