import javax.swing.BorderFactory;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.border.EtchedBorder;
import javax.swing.border.TitledBorder;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.swing.table.DefaultTableModel;
import javax.swing.JCheckBox;
import javax.swing.JButton;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.JTable;

import SecureBlackbox.Base.TElMemoryCertStorage;

import java.awt.Dimension;

public class OptionsDialog extends JDialog {

	private static final long serialVersionUID = 1L;
	private JTable table;
	private boolean isOk;
	private JCheckBox cbSSL2;
	private JCheckBox cbSSL3;
	private JCheckBox cbTLS1;
	private JCheckBox cbTLS11;
	private JCheckBox cbTLS12;
	private JCheckBox cbUseOnlyExportable;
	private JCheckBox cbAllowAnonymousSessions;
	private JCheckBox cbStrictCertificateValidation;
	
	public OptionsDialog() {
		setSize(new Dimension(430, 445));
		getContentPane().setLayout(null);
		
		JPanel panel = new JPanel();
		panel.setBorder(new TitledBorder(null, "Encryption options", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		panel.setBounds(10, 11, 400, 143);
		getContentPane().add(panel);
		panel.setLayout(null);
		
		cbSSL2 = new JCheckBox("SSL2");
		cbSSL2.setBounds(6, 19, 63, 23);
		panel.add(cbSSL2);
		
		cbSSL3 = new JCheckBox("SSL3");
		cbSSL3.setBounds(71, 19, 63, 23);
		panel.add(cbSSL3);
		
		cbTLS1 = new JCheckBox("TLS1");
		cbTLS1.setSelected(true);
		cbTLS1.setBounds(146, 19, 72, 23);
		panel.add(cbTLS1);
		
		cbTLS11 = new JCheckBox("TLS1.1");
		cbTLS11.setSelected(true);
		cbTLS11.setBounds(220, 19, 78, 23);
		panel.add(cbTLS11);
		
		cbTLS12 = new JCheckBox("TLS1.2");
		cbTLS12.setSelected(true);
		cbTLS12.setBounds(290, 19, 78, 23);
		panel.add(cbTLS12);
		
		cbUseOnlyExportable = new JCheckBox("Use only exportable ciphersuites");
		cbUseOnlyExportable.setBounds(6, 55, 225, 23);
		panel.add(cbUseOnlyExportable);
		
		cbAllowAnonymousSessions = new JCheckBox("Allow anonymous sessions");
		cbAllowAnonymousSessions.setBounds(6, 81, 247, 23);
		panel.add(cbAllowAnonymousSessions);
		
		cbStrictCertificateValidation = new JCheckBox("Strict certificate validation");
		cbStrictCertificateValidation.setBounds(6, 107, 292, 23);
		panel.add(cbStrictCertificateValidation);
		
		JPanel panel_1 = new JPanel();
		panel_1.setBorder(new TitledBorder(null, "Certificates", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		panel_1.setBounds(10, 156, 398, 207);
		getContentPane().add(panel_1);
		panel_1.setLayout(null);
		
		JButton btnAdd = new JButton("Add");
		btnAdd.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				addCert();
			}
		});
		btnAdd.setBounds(297, 35, 91, 23);
		panel_1.add(btnAdd);
		
		JButton btnRemove = new JButton("Remove");
		btnRemove.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				removeCert();
			}
		});
		btnRemove.setBounds(297, 69, 91, 23);
		panel_1.add(btnRemove);
		
		table = new JTable();
		table.setFillsViewportHeight(true);
		JScrollPane scrollPane = new JScrollPane(table);
		scrollPane.setBounds(10, 23, 277, 173);
		scrollPane.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED)); 

		panel_1.add(scrollPane);
		
		JButton btnOk = new JButton("Ok");
		btnOk.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				setVisible(false);
				isOk = true;
			}
		});
		btnOk.setBounds(140, 383, 91, 23);
		getContentPane().add(btnOk);
		
		JButton btnCancel = new JButton("Cancel");
		btnCancel.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				isOk = false;
				dispose();
			}
		});
		btnCancel.setBounds(241, 383, 91, 23);
		getContentPane().add(btnCancel);
	}

	protected void removeCert() {
		OptionsTableModel model = (OptionsTableModel)table.getModel();
		int[] rows = table.getSelectedRows();
		model.removeSelectedItems(rows);
	}

	protected void addCert() {
		String certFileName = getCertFile();
		try {
			table.setModel(new OptionsTableModel(certFileName));
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	protected String getCertFile() {
		JFileChooser fc = new JFileChooser();

		FileNameExtensionFilter filter = new FileNameExtensionFilter("PKCS#12 | PEM-formatted | Plain certificates", "pfx", "pem", "cer");
	    fc.setFileFilter(filter);		 
	    
	    int returnVal = fc.showOpenDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	}

	public void setCertificates(TElMemoryCertStorage str) {
		clearTable();
		Object model = table.getModel();
		if (model instanceof OptionsTableModel) {
			((OptionsTableModel)model).setCertificates(str);
		}
	}
	
	private void clearTable() {
		Object model = table.getModel();
		if (model instanceof OptionsTableModel)
		{
			((OptionsTableModel) model).dataVector.removeAllElements();
			((OptionsTableModel) model).fireTableDataChanged();
		}
		else
			((DefaultTableModel) model).setNumRows(0);
	}
	
	public void setSSL2(boolean bUseSSL2) {
		cbSSL2.setSelected(bUseSSL2);
	}

	public void setSSL3(boolean bUseSSL3) {
		cbSSL3.setSelected(bUseSSL3);
	}

	public void setTLS1(boolean bUseTLS1) {
		cbTLS1.setSelected(bUseTLS1);
	}

	public void setTLS11(boolean bUseTLS11) {
		cbTLS11.setSelected(bUseTLS11);
	}
	
	public void setTLS12(boolean bUseTLS12) {
		cbTLS12.setSelected(bUseTLS12);
	}

	public void setAllowAnon(boolean bAllowAnonymous) {
		cbAllowAnonymousSessions.setSelected(bAllowAnonymous);
	}

	public void setExportableOnly(boolean bUseOnlyExportable) {
		cbUseOnlyExportable.setSelected(bUseOnlyExportable);
	}

	public void setStrictCertValidation(boolean bStrictCertValidation) {
		cbStrictCertificateValidation.setSelected(bStrictCertValidation);
	}

	public void getCertificates(TElMemoryCertStorage str) {
		str.clear();
		((OptionsTableModel)table.getModel()).getCertificates().exportTo(str);
	}

	public boolean getSSL2() {
		return cbSSL2.isSelected();
	}

	public boolean getSSL3() {
		return cbSSL3.isSelected();
	}

	public boolean getTLS1() {
		return cbTLS1.isSelected();
	}

	public boolean getTLS11() {
		return cbTLS11.isSelected();
	}
	
	public boolean getTLS12() {
		return cbTLS12.isSelected();
	}

	public boolean getAllowAnon() {
		return cbAllowAnonymousSessions.isSelected();
	}

	public boolean getExportableOnly() {
		return cbUseOnlyExportable.isSelected();
	}

	public boolean getStrictCertValidation() {
		return cbStrictCertificateValidation.isSelected();
	}

	public boolean isOk() {
		return isOk;
	}
}
