import java.util.Vector;

import javax.swing.table.AbstractTableModel;
import SecureBlackbox.DAVClient.TElWebDAVStorageObject;

public class ObjectsTableModel extends AbstractTableModel {
	private static final long serialVersionUID = 2771284071470299948L;
	public static final int NAME_INDEX = 0;
	public static final int SIZE_INDEX = 1;
	public static final int CREA_INDEX = 2;
	public static final int LOCK_INDEX = 3;
	
	protected Vector<ObjectsDataRow> dataVector = new Vector<ObjectsDataRow>();
	
    protected String[] columnNames = {
    		"Name",
    		"Size", 
    		"Created",
    		"Locked",
    };
        
	public String getColumnName(int column) {
        return columnNames[column];
    }
    
	public int getColumnCount() {
		return columnNames.length;
	}

	public int getRowCount() {
		return dataVector.size();
	}

    public Object getValueAt(int row, int col) {
        ObjectsDataRow record = (ObjectsDataRow)dataVector.get(row);
        switch (col) {
        	case NAME_INDEX:
        		return record.Name;
        	case SIZE_INDEX:
	        	 return record.Size;
            case CREA_INDEX:
               return record.Created;
            case LOCK_INDEX:
                return record.Locked;               
            default:
               return new Object();
        }
    }

	public void clear() {
		dataVector.removeAllElements();
		fireTableDataChanged();
	}

	public TElWebDAVStorageObject getTag(int row) {
		return dataVector.get(row).Tag;
	}

	public void addItem(TElWebDAVStorageObject item) {
		TElWebDAVStorageObject tag = (TElWebDAVStorageObject)item;
		
		String name = item.getDisplayName();
		String size = tag.getContentLength() + "";
		String created = item.getCreationDate().toString();
		String locked = (item.getLocks().getLockCount() > 0) ? "yes" : "no";
		
		dataVector.addElement(new ObjectsDataRow(name, size, created, locked, tag.clone()));
		fireTableDataChanged();		
	}
}