import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.JComboBox;
import javax.swing.JButton;
import javax.swing.GroupLayout;
import javax.swing.GroupLayout.Alignment;
import javax.swing.LayoutStyle.ComponentPlacement;
import javax.swing.JTree;
import javax.swing.tree.*;
import javax.swing.DefaultComboBoxModel;

import SecureBlackbox.Base.SBUtils;
import SecureBlackbox.HTTPClient.TElHTTPSClient;
import SecureBlackbox.SOAPClient.TElXMLSOAPBaseParameter;
import SecureBlackbox.SOAPClient.TElXMLSOAPClient;
import SecureBlackbox.SOAPClient.TElXMLSOAPCompoundParameter;
import SecureBlackbox.SOAPClient.TElXMLSOAPCustomParameter;
import SecureBlackbox.SOAPClient.TElXMLSOAPFault;
import SecureBlackbox.SOAPClient.TSBXMLSOAPResponseType;
import SecureBlackbox.XMLSecurity.SBXMLSOAPCore;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import javax.swing.JTextArea;


public class MainFrm {

	private JFrame frame;
	private JTextField textURL;
	private JTextField textSOAPAction;
	private JTextField textOperationName;
	private JTextField textOperationPrefix;
	private JTextField textOperationNamespaceURI;
	
	private JTree treeParameters;
	private JTree treeResults;
	private JComboBox cmbSOAPAction;
	private JTextArea textValue;
	
	private TElHTTPSClient httpsClient = new TElHTTPSClient();
	private TElXMLSOAPClient soapClient = new TElXMLSOAPClient();;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					MainFrm window = new MainFrm();
					window.frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the application.
	 */
	public MainFrm() {
		#error Please pick the evaluation license key from <SecureBlackbox>\LicenseKey.txt file and place it here. If the evaluation key expires, you can request an extension using the form on https://www.eldos.com/sbb/keyreq/
		SBUtils.setLicenseKey("<put the key here>");

		initialize();
	}

	/**
	 * Initialize the contents of the frame.
	 */
	private void initialize() {
		frame = new JFrame();
		frame.setBounds(100, 100, 547, 528);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		JLabel lblNewLabel = new JLabel("Service URL:");
		
		JLabel lblSoapAction = new JLabel("SOAP Action:");
		
		JLabel lblSoapVersion = new JLabel("SOAP Version:");
		
		textURL = new JTextField();
		textURL.setColumns(10);
		
		textSOAPAction = new JTextField();
		textSOAPAction.setColumns(10);
		
		cmbSOAPAction = new JComboBox();
		cmbSOAPAction.setModel(new DefaultComboBoxModel(new String[] {"1.1", "1.2"}));
		
		JButton btnSend = new JButton("Send");
		btnSend.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				doSendClick();
			}
		});
		
		JLabel lblNewLabel_1 = new JLabel("Operation name:");
		
		JLabel lblNewLabel_2 = new JLabel("Operation namespace URI:");
		
		JLabel lblNewLabel_3 = new JLabel("Prefix:");
		
		textOperationName = new JTextField();
		textOperationName.setColumns(10);
		
		textOperationPrefix = new JTextField();
		textOperationPrefix.setColumns(10);
		
		textOperationNamespaceURI = new JTextField();
		textOperationNamespaceURI.setColumns(10);
		
		JLabel lblNewLabel_4 = new JLabel("Parameters:");
		
		treeParameters = new JTree();
		
		JButton btnNewButton_1 = new JButton("Add");
		btnNewButton_1.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				doAddParameterClick();
			}
		});
		
		JButton btnNewButton_2 = new JButton("Delete");
		
		treeResults = new JTree();
		
		JLabel lblNewLabel_5 = new JLabel("Results:");
		
		JScrollPane scrollPane = new JScrollPane();
		
		GroupLayout groupLayout = new GroupLayout(frame.getContentPane());
		groupLayout.setHorizontalGroup(
			groupLayout.createParallelGroup(Alignment.TRAILING)
				.addGroup(groupLayout.createSequentialGroup()
					.addGroup(groupLayout.createParallelGroup(Alignment.TRAILING)
						.addGroup(Alignment.LEADING, groupLayout.createSequentialGroup()
							.addContainerGap()
							.addComponent(scrollPane, GroupLayout.DEFAULT_SIZE, 505, Short.MAX_VALUE))
						.addGroup(Alignment.LEADING, groupLayout.createSequentialGroup()
							.addGap(10)
							.addGroup(groupLayout.createParallelGroup(Alignment.LEADING)
								.addGroup(groupLayout.createSequentialGroup()
									.addGroup(groupLayout.createParallelGroup(Alignment.LEADING)
										.addGroup(groupLayout.createSequentialGroup()
											.addComponent(lblNewLabel)
											.addGap(18)
											.addComponent(textURL, GroupLayout.PREFERRED_SIZE, 323, GroupLayout.PREFERRED_SIZE))
										.addGroup(groupLayout.createSequentialGroup()
											.addComponent(lblSoapAction)
											.addGap(18)
											.addComponent(textSOAPAction, GroupLayout.PREFERRED_SIZE, 323, GroupLayout.PREFERRED_SIZE)))
									.addGap(18)
									.addComponent(btnSend, GroupLayout.DEFAULT_SIZE, 82, Short.MAX_VALUE))
								.addGroup(groupLayout.createSequentialGroup()
									.addComponent(lblSoapVersion)
									.addGap(10)
									.addComponent(cmbSOAPAction, GroupLayout.PREFERRED_SIZE, 88, GroupLayout.PREFERRED_SIZE)))
							.addPreferredGap(ComponentPlacement.RELATED))
						.addGroup(Alignment.LEADING, groupLayout.createSequentialGroup()
							.addContainerGap()
							.addComponent(lblNewLabel_2)
							.addPreferredGap(ComponentPlacement.UNRELATED)
							.addComponent(textOperationNamespaceURI, GroupLayout.DEFAULT_SIZE, 365, Short.MAX_VALUE))
						.addGroup(Alignment.LEADING, groupLayout.createSequentialGroup()
							.addContainerGap()
							.addComponent(lblNewLabel_1)
							.addPreferredGap(ComponentPlacement.UNRELATED)
							.addComponent(textOperationName, GroupLayout.DEFAULT_SIZE, 268, Short.MAX_VALUE)
							.addGap(18)
							.addComponent(lblNewLabel_3)
							.addPreferredGap(ComponentPlacement.UNRELATED)
							.addComponent(textOperationPrefix, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
						.addGroup(Alignment.LEADING, groupLayout.createSequentialGroup()
							.addContainerGap()
							.addGroup(groupLayout.createParallelGroup(Alignment.LEADING)
								.addGroup(groupLayout.createSequentialGroup()
									.addComponent(treeParameters, GroupLayout.PREFERRED_SIZE, 200, GroupLayout.PREFERRED_SIZE)
									.addPreferredGap(ComponentPlacement.RELATED)
									.addGroup(groupLayout.createParallelGroup(Alignment.LEADING)
										.addComponent(btnNewButton_2, GroupLayout.DEFAULT_SIZE, 93, Short.MAX_VALUE)
										.addComponent(btnNewButton_1, GroupLayout.DEFAULT_SIZE, 93, Short.MAX_VALUE)))
								.addComponent(lblNewLabel_4))
							.addPreferredGap(ComponentPlacement.RELATED)
							.addGroup(groupLayout.createParallelGroup(Alignment.LEADING)
								.addComponent(lblNewLabel_5)
								.addComponent(treeResults, GroupLayout.PREFERRED_SIZE, 200, GroupLayout.PREFERRED_SIZE))))
					.addGap(16))
		);
		groupLayout.setVerticalGroup(
			groupLayout.createParallelGroup(Alignment.TRAILING)
				.addGroup(groupLayout.createSequentialGroup()
					.addGroup(groupLayout.createParallelGroup(Alignment.LEADING)
						.addGroup(groupLayout.createSequentialGroup()
							.addGap(11)
							.addGroup(groupLayout.createParallelGroup(Alignment.BASELINE)
								.addComponent(lblNewLabel)
								.addComponent(textURL, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
							.addGap(8)
							.addGroup(groupLayout.createParallelGroup(Alignment.BASELINE)
								.addComponent(lblSoapAction)
								.addComponent(textSOAPAction, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
							.addGap(3))
						.addGroup(groupLayout.createSequentialGroup()
							.addContainerGap()
							.addComponent(btnSend, GroupLayout.DEFAULT_SIZE, 51, Short.MAX_VALUE)))
					.addGroup(groupLayout.createParallelGroup(Alignment.LEADING)
						.addGroup(groupLayout.createSequentialGroup()
							.addGap(8)
							.addComponent(lblSoapVersion))
						.addGroup(groupLayout.createSequentialGroup()
							.addGap(5)
							.addComponent(cmbSOAPAction, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)))
					.addGap(36)
					.addGroup(groupLayout.createParallelGroup(Alignment.BASELINE)
						.addComponent(lblNewLabel_1)
						.addComponent(lblNewLabel_3)
						.addComponent(textOperationName, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
						.addComponent(textOperationPrefix, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addPreferredGap(ComponentPlacement.UNRELATED)
					.addGroup(groupLayout.createParallelGroup(Alignment.BASELINE)
						.addComponent(lblNewLabel_2)
						.addComponent(textOperationNamespaceURI, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addGap(28)
					.addGroup(groupLayout.createParallelGroup(Alignment.BASELINE)
						.addComponent(lblNewLabel_4)
						.addComponent(lblNewLabel_5))
					.addPreferredGap(ComponentPlacement.RELATED)
					.addGroup(groupLayout.createParallelGroup(Alignment.LEADING)
						.addComponent(treeParameters, GroupLayout.PREFERRED_SIZE, 118, GroupLayout.PREFERRED_SIZE)
						.addGroup(groupLayout.createParallelGroup(Alignment.BASELINE)
							.addGroup(groupLayout.createSequentialGroup()
								.addComponent(btnNewButton_1)
								.addGap(5)
								.addComponent(btnNewButton_2))
							.addComponent(treeResults, GroupLayout.PREFERRED_SIZE, 118, GroupLayout.PREFERRED_SIZE)))
					.addPreferredGap(ComponentPlacement.UNRELATED)
					.addComponent(scrollPane, GroupLayout.PREFERRED_SIZE, 110, GroupLayout.PREFERRED_SIZE)
					.addContainerGap())
		);
		
		textValue = new JTextArea();
		scrollPane.setViewportView(textValue);
		frame.getContentPane().setLayout(groupLayout);
		
		DefaultMutableTreeNode root = new DefaultMutableTreeNode("Body");
		treeParameters.setModel(new DefaultTreeModel(root));
		
		treeParameters.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent me) {
				final TreePath tp = treeParameters.getPathForLocation(me.getX(), me.getY());
				final Object o = (tp != null) ? tp.getLastPathComponent() : null;
				
				if ((o != null) && (o instanceof SOAPMutableTreeNode))
					updateValue(((SOAPMutableTreeNode)tp.getLastPathComponent()).getParameter());
				else
					updateValue(null);
		    }
		});
		
		root = new DefaultMutableTreeNode("Response");
		treeResults.setModel(new DefaultTreeModel(root));
		
		treeResults.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent me) {
				final TreePath tp = treeResults.getPathForLocation(me.getX(), me.getY());
				final Object o = (tp != null) ? tp.getLastPathComponent() : null;
				
				if ((o != null) && (o instanceof SOAPMutableTreeNode))
					updateValue(((SOAPMutableTreeNode)tp.getLastPathComponent()).getParameter());
				else
					updateValue(null);
		    }
		});
	}
	
	private void doSendClick() {
		soapClient.setSOAPPrefix("soap");
		
		if (cmbSOAPAction.getSelectedIndex() == 0)
			soapClient.setSOAPVersion(SBXMLSOAPCore.SOAP_v1_1);
		else
			soapClient.setSOAPVersion(SBXMLSOAPCore.SOAP_v1_2);
		
		soapClient.setOperationName(textOperationName.getText());
		soapClient.setOperationNamespaceURI(textOperationNamespaceURI.getText());
		
		final String prefix = textOperationPrefix.getText();
		if (prefix.length() > 0)
			soapClient.getMessageNamespaces().addNamespace(prefix, textOperationNamespaceURI.getText());
		else
			soapClient.getMessageNamespaces().clear();
		
		soapClient.generateMessage();
		
		soapClient.setHTTPClient(httpsClient);
		soapClient.setURL(textURL.getText());
		soapClient.setSOAPAction(textSOAPAction.getText());
		
		soapClient.sendMessage();
		
		updateResponse();
	}
	
	private void addResponseCompoundParameter(TElXMLSOAPCompoundParameter params, DefaultMutableTreeNode rootNode) {
		for (int i = 0; i < params.getCount(); i++) {
			SOAPMutableTreeNode item = new SOAPMutableTreeNode(params.getItems(i).getParameterName(), params.getItems(i));
			rootNode.add(item);
			
			if (params.getItems(i) instanceof TElXMLSOAPCompoundParameter)
				addResponseCompoundParameter((TElXMLSOAPCompoundParameter)params.getItems(i), item);
		}
	}
	
	private void updateResponse() {
		DefaultMutableTreeNode resp = new DefaultMutableTreeNode("Response");
		
		DefaultMutableTreeNode root = new DefaultMutableTreeNode("Body");
		resp.add(root);
		
		for (int i = 0; i < soapClient.getResponseParameterCount(); i++) {
			SOAPMutableTreeNode item = new SOAPMutableTreeNode(soapClient.getResponseParameterNames(i), soapClient.getResponseParameters(i));
			root.add(item);
			
			if (soapClient.getResponseParameters(i) instanceof TElXMLSOAPCompoundParameter)
				addResponseCompoundParameter((TElXMLSOAPCompoundParameter)soapClient.getResponseParameters(i), item);
		}
		
		if (soapClient.getFaultCount() > 0) {
			DefaultMutableTreeNode faults = new DefaultMutableTreeNode("Faults");
			resp.add(faults);
			
			for (int i = 0; i < soapClient.getFaultCount(); i++) {
				SOAPMutableTreeNode item = new SOAPMutableTreeNode("Fault", soapClient.getFaults(i));
				faults.add(item);
			}
		}
		
		treeResults.setModel(new DefaultTreeModel(resp));
		
		updateValue(soapClient);
	}
	
	private void doAddParameterClick() {
		ParameterFrm frm = new ParameterFrm();
		frm.setModal(true);
		frm.setVisible(true);
		
		if (frm.isOK()) {
			frm.addParameter(soapClient);
			updateParameters();
		}
	}
	
	private void addCompoundParameter(TElXMLSOAPCompoundParameter params, DefaultMutableTreeNode rootNode) {
		for (int i = 0; i < params.getCount(); i++) {
			SOAPMutableTreeNode item = new SOAPMutableTreeNode(params.getItems(i).getParameterName(), params.getItems(i));
			rootNode.add(item);
			
			if (params.getItems(i) instanceof TElXMLSOAPCompoundParameter)
				addCompoundParameter((TElXMLSOAPCompoundParameter)params.getItems(i), item);
		}
	}
	
	private void updateParameters() {
		DefaultMutableTreeNode root = new DefaultMutableTreeNode("Body");
		
		for (int i = 0; i < soapClient.getParameterCount(); i++) {
			SOAPMutableTreeNode item = new SOAPMutableTreeNode(soapClient.getParameterNames(i), soapClient.getParameters(i));
			root.add(item);
			
			if (soapClient.getParameters(i) instanceof TElXMLSOAPCompoundParameter)
				addCompoundParameter((TElXMLSOAPCompoundParameter)soapClient.getParameters(i), item);
		}
		
		treeParameters.setModel(new DefaultTreeModel(root));
		
		updateValue(null);
	}
	
	private void updateValue(Object obj) {
		if (obj == null) {
			textValue.setText("");
			return;
		}
		
		StringBuilder sb = new StringBuilder();
		
		if (obj instanceof TElXMLSOAPCustomParameter) {
			sb.append("Parameter name: ").append(((TElXMLSOAPCustomParameter)obj).getParameterName()).append("\n");
			sb.append("Parameter namespace URI: ").append(((TElXMLSOAPCustomParameter)obj).getParameterNamespaceURI()).append("\n");
			if (obj instanceof TElXMLSOAPBaseParameter)
				sb.append("Value: \n").append(((TElXMLSOAPBaseParameter)obj).getStringValue());
		} else if (obj instanceof TElXMLSOAPFault) {
			sb.append("Fault code: ").append(((TElXMLSOAPFault)obj).getFaultCode()).append("\n");
			sb.append("Fault actor: ").append(((TElXMLSOAPFault)obj).getFaultActor()).append("\n");
			sb.append("Details: \n").append(((TElXMLSOAPFault)obj).getDetail());
		} else if (obj instanceof TElXMLSOAPClient) {
			sb.append("Server status code: ").append(Integer.toString(soapClient.getHTTPStatusCode())).append("\n");
			
			String s;
			if (soapClient.getResponseType() == TSBXMLSOAPResponseType.Stream)
				s = "Stream";
			else if (soapClient.getResponseType() == TSBXMLSOAPResponseType.XMLDocument)
				s = "XML Document";
			else if (soapClient.getResponseType() == TSBXMLSOAPResponseType.SOAPMessage)
				s = "SOAP Message";
			else
				s = "None";
			
			sb.append("Response: ").append(s);
		}
		
		textValue.setText(sb.toString());
	}
	
	// -------------------------------- //
	
	private class SOAPMutableTreeNode extends DefaultMutableTreeNode {
		private static final long serialVersionUID = 1L;
		
		private Object param;
		
		public SOAPMutableTreeNode(Object userObject, Object param) {
			super(userObject);
			this.param = param;
		}
		
		public Object getParameter() {
			return param;
		}
	}
}
