import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.text.SimpleDateFormat;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.JComboBox;
import javax.swing.DefaultComboBoxModel;

import SecureBlackbox.SOAPClient.TElXMLSOAPClient;


public class ParameterFrm extends JDialog {

	private static final long serialVersionUID = 1L;
	
	private final JPanel contentPanel = new JPanel();
	private JTextField textName;
	private JTextField textNamespaceURI;
	private JTextField textValue;
	
	private JComboBox cmbType;
	private JComboBox cmbBooleanValue;
	
	private boolean isOk;

	private static final SimpleDateFormat fmt = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss");
	
	/**
	 * Create the dialog.
	 */
	public ParameterFrm() {
		setBounds(100, 100, 336, 227);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		{
			JLabel lblNewLabel = new JLabel("New label");
			lblNewLabel.setBounds(10, 11, 46, 14);
			contentPanel.add(lblNewLabel);
		}
		{
			textName = new JTextField();
			textName.setBounds(66, 8, 240, 20);
			contentPanel.add(textName);
			textName.setColumns(10);
		}
		{
			JLabel lblNewLabel_1 = new JLabel("New label");
			lblNewLabel_1.setBounds(10, 42, 46, 14);
			contentPanel.add(lblNewLabel_1);
		}
		{
			textNamespaceURI = new JTextField();
			textNamespaceURI.setBounds(66, 39, 240, 20);
			contentPanel.add(textNamespaceURI);
			textNamespaceURI.setColumns(10);
		}
		{
			JLabel lblNewLabel_2 = new JLabel("New label");
			lblNewLabel_2.setBounds(10, 73, 46, 14);
			contentPanel.add(lblNewLabel_2);
		}
		
		cmbType = new JComboBox();
		cmbType.setModel(new DefaultComboBoxModel(new String[] {"String", "Integer", "Int64", "Double", "DateTime", "Boolean", "Base64 String", "Compound Structure"}));
		cmbType.setBounds(66, 70, 240, 20);
		contentPanel.add(cmbType);
		cmbType.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				doComboTypeChanged();
			}
		});
		
		textValue = new JTextField();
		textValue.setBounds(10, 109, 296, 20);
		contentPanel.add(textValue);
		textValue.setColumns(10);
		
		cmbBooleanValue = new JComboBox();
		cmbBooleanValue.setModel(new DefaultComboBoxModel(new String[] {"false", "true"}));
		cmbBooleanValue.setBounds(10, 109, 296, 20);
		cmbBooleanValue.setVisible(false);
		contentPanel.add(cmbBooleanValue);
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				JButton okButton = new JButton("OK");
				okButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						isOk = true;
						setVisible(false);
					}
				});
				okButton.setActionCommand("OK");
				buttonPane.add(okButton);
				getRootPane().setDefaultButton(okButton);
			}
			{
				JButton cancelButton = new JButton("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						isOk = false;
						setVisible(false);
					}
				});
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
			}
		}
	}
	
	public void addParameter(TElXMLSOAPClient soapClient) {
		final String s = ((String)cmbType.getSelectedItem()).toLowerCase();
		
		try {
			if ("string".equals(s))
				soapClient.addStringParameter(textName.getText(), textNamespaceURI.getText(), textValue.getText());
			else if ("integer".equals(s))
				soapClient.addIntegerParameter(textName.getText(), textNamespaceURI.getText(), Integer.parseInt(textValue.getText()));
			else if ("int64".equals(s))
				soapClient.addInt64Parameter(textName.getText(), textNamespaceURI.getText(), Long.parseLong(textValue.getText()));
			else if ("double".equals(s))
				soapClient.addDoubleParameter(textName.getText(), textNamespaceURI.getText(), Double.parseDouble(textValue.getText()));
			else if ("datetime".equals(s))
				soapClient.addDateTimeParameter(textName.getText(), textNamespaceURI.getText(), fmt.parse(textValue.getText()));
			else if ("boolean".equals(s))
				soapClient.addBooleanParameter(textName.getText(), textNamespaceURI.getText(), Boolean.parseBoolean((String) cmbBooleanValue.getItemAt(cmbBooleanValue.getSelectedIndex())));
			else if ("base64 string".equals(s))
				soapClient.addBase64BinaryParameter(textName.getText(), textNamespaceURI.getText(), textValue.getText().getBytes("UTF-8"));
			else if ("compound structure".equals(s))
				soapClient.addCompoundParameter(textName.getText(), textNamespaceURI.getText());
		} catch (Exception ex) {
			showErrorMessage(ex.getMessage(), "Error");
		}
	}
	
	public void doComboTypeChanged() {
		textValue.setVisible(false);
		cmbBooleanValue.setVisible(false);
		
		final String type = (String) cmbType.getItemAt(cmbType.getSelectedIndex());
		
		if ("boolean".equals(type.toLowerCase()))
			cmbBooleanValue.setVisible(true);
		else
			textValue.setVisible(true);
	}
	
	public boolean isOK() {
		return isOk;
	}
	
	private void showErrorMessage(String msg, String cap) {
		JOptionPane.showMessageDialog(null, msg, cap, JOptionPane.ERROR_MESSAGE);		
	}
}
