

import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.JTree;
import javax.swing.JTextArea;
import javax.swing.border.LineBorder;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreeModel;
import javax.swing.tree.TreePath;

import SecureBlackbox.Base.*;
import SecureBlackbox.PGP.TElPGPPublicKey;
import SecureBlackbox.PGP.TElPGPSecretKey;
import SecureBlackbox.XML.*;
import SecureBlackbox.XMLSecurity.*;

import java.awt.Color;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.io.FileInputStream;
import java.io.IOException;

	  
class Main extends JDialog {
	private static final long serialVersionUID = -8938687539889635131L;
	private final JPanel contentPanel = new JPanel();
	private JTextField edXMLFile;
	private TElXMLDOMDocument FXMLDocument = null;
	JTextArea mmXML;
	JTree tvXML;
	DefaultMutableTreeNode rootNode;
	private JLabel lNodeType;
	private JLabel lNamespace;
	
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			Main dialog = new Main();
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog.
	 */
	public Main() {
		#error Please pick the evaluation license key from <SecureBlackbox>\LicenseKey.txt file and place it here. If the evaluation key expires, you can request an extension using the form on https://www.eldos.com/sbb/keyreq/
		SBUtils.setLicenseKey("<put the key here>");

		FXMLDocument = new TElXMLDOMDocument();
		rootNode = new DefaultMutableTreeNode("#");
	
		setBounds(100, 100, 454, 611);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		
		JLabel lblXmlFile = new JLabel("XML File");
		lblXmlFile.setBounds(10, 11, 61, 14);
		contentPanel.add(lblXmlFile);
		
		edXMLFile = new JTextField();
		edXMLFile.setBounds(74, 8, 321, 20);
		contentPanel.add(edXMLFile);
		edXMLFile.setColumns(10);
		
		JButton sbBrowseXMLFile = new JButton(".");
		sbBrowseXMLFile.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				edXMLFile.setText(getXMLFileName());
			}
		});
		sbBrowseXMLFile.setBounds(405, 7, 29, 23);
		contentPanel.add(sbBrowseXMLFile);
		
		tvXML = new JTree(rootNode);
		tvXML.setBorder(new LineBorder(new Color(0, 0, 0)));
		tvXML.setBounds(10, 47, 321, 347);
		tvXML.addTreeSelectionListener(new TreeSelectionListener() {
			public void valueChanged(TreeSelectionEvent e) {
				onNodeSelect();
			}
		});
		contentPanel.add(tvXML);
		
		JButton btnLoadXml = new JButton("Load XML");
		btnLoadXml.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				loadXML(edXMLFile.getText());
			}
		});
		btnLoadXml.setBounds(343, 44, 91, 23);
		contentPanel.add(btnLoadXml);
		
		JButton btnSaveXml = new JButton("Save XML");
		btnSaveXml.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				saveXML();
			}
		});
		btnSaveXml.setBounds(343, 71, 91, 23);
		contentPanel.add(btnSaveXml);
		
		JButton btnDelete = new JButton("Delete");
		btnDelete.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				deleteSelectedNodes();
			}
		});
		btnDelete.setBounds(343, 145, 91, 23);
		contentPanel.add(btnDelete);
		
		JButton btnClear = new JButton("Clear");
		btnClear.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				clear();
			}
		});
		btnClear.setBounds(343, 179, 91, 23);
		contentPanel.add(btnClear);
		
		JButton btnEncrypt = new JButton("Encrypt");
		btnEncrypt.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				try {
					encrypt();
				} catch (IOException ex) {
					ex.printStackTrace();
					showErrorMessage(ex.getMessage());
				}
			}
		});
		btnEncrypt.setBounds(343, 327, 91, 23);
		contentPanel.add(btnEncrypt);
		
		JButton btnDecrypt = new JButton("Decrypt");
		btnDecrypt.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				try {
					decrypt();
				} catch (IOException ex) {
					ex.printStackTrace();
					showErrorMessage(ex.getMessage());
				}
			}
		});
		btnDecrypt.setBounds(343, 356, 91, 23);
		contentPanel.add(btnDecrypt);
		
		JLabel lblNodeType = new JLabel("Node type:");
		lblNodeType.setBounds(10, 405, 96, 14);
		contentPanel.add(lblNodeType);
		
		JLabel lblNamespaceUri = new JLabel("Namespace URI:");
		lblNamespaceUri.setBounds(10, 430, 96, 14);
		contentPanel.add(lblNamespaceUri);
		
		mmXML = new JTextArea();
		mmXML.setBorder(new LineBorder(new Color(0, 0, 0)));
		mmXML.setBounds(10, 455, 424, 85);
		contentPanel.add(mmXML);
		
		lNamespace = new JLabel(" ");
		lNamespace.setBounds(98, 430, 336, 14);
		contentPanel.add(lNamespace);
		
		lNodeType = new JLabel(" ");
		lNodeType.setBounds(98, 405, 336, 14);
		contentPanel.add(lNodeType);
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				JButton okButton = new JButton("OK");
				okButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						dispose();
					}
				});
				okButton.setActionCommand("OK");
				buttonPane.add(okButton);
				getRootPane().setDefaultButton(okButton);
			}
			{
				JButton cancelButton = new JButton("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						dispose();
					}
				});
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
			}
		}
	}

	protected void decrypt() throws IOException {
			TElXMLDecryptor Decryptor;
			TElXMLKeyInfoSymmetricData SymKeyData, SymKEKData = null;
			TElXMLKeyInfoRSAData RSAKeyData = null;
			TElXMLKeyInfoX509Data X509KeyData = null;
			TElXMLKeyInfoPGPData PGPKeyData = null;
			FileInputStream F;
			TElFileStream lF;			
			TElXMLDOMNode Node, T;
			int i;
			
		    TreePath[] paths = tvXML.getSelectionPaths();

			if (paths == null || paths.length == 0)
				Node = (TElXMLDOMNode)FXMLDocument;
			else
				Node = getFirstNode(paths);

			while ((Node instanceof TElXMLDOMElement) &&
				(((TElXMLDOMElement)Node).getLocalName().compareTo("EncryptedData") != 0) &&
				(Node.getParentNode() != null))
				Node = Node.getParentNode();

			if ((Node instanceof TElXMLDOMElement) &&
				(((TElXMLDOMElement)Node).getLocalName().compareTo("EncryptedData") == 0) &&
				(Node.getParentNode() != null) &&
				(Node.getParentNode() instanceof TElXMLDOMDocument))
				Node = Node.getParentNode();

			if (Node instanceof TElXMLDOMDocument)
				T = ((TElXMLDOMDocument) Node).getDocumentElement();
			else
				T = Node;

			if (!(T instanceof TElXMLDOMElement) ||
				(((TElXMLDOMElement)T).getLocalName().compareTo("EncryptedData")) != 0)
			{
				showMessage("", "Please, select EncryptedData element or Document for decryption.");
				return;
			}

			Decryptor = new TElXMLDecryptor();
			try
			{
				try
				{
					if (Node instanceof TElXMLDOMDocument)
						Decryptor.load((TElXMLDOMDocument)Node);
					else
						Decryptor.load((TElXMLDOMElement)Node);
				}
				catch (Exception E)
				{
					E.printStackTrace();
					showErrorMessage("Encrypted data loading failed. " + E.getMessage());
					return;
				}

				EncDialog frmEnc = new EncDialog();
				frmEnc.setModal(true);
				
				frmEnc.setEncryptKey(Decryptor.getEncryptKey());
				frmEnc.setEncryptedDataType(Decryptor.getEncryptedDataType());
				frmEnc.setEncryptionMethod(Decryptor.getEncryptionMethod());
				frmEnc.setKeyEncryptionType(Decryptor.getKeyEncryptionType());
				frmEnc.setKeyTransportMethod(Decryptor.getKeyTransportMethod());
				frmEnc.setKeyWrapMethod(Decryptor.getKeyWrapMethod());
				frmEnc.setKeyName(Decryptor.getKeyName());
				frmEnc.setMimeType(Decryptor.getMimeType());
				frmEnc.setLockOpt(true);
				frmEnc.updateOpt();
				
				frmEnc.setVisible(true);

				while (true)
				{
					if (frmEnc.isOK())
					{
						if (Decryptor.getEncryptKey())
						{
							if (Decryptor.getKeyEncryptionType() == SBXMLSec.xetKeyWrap)
							{
								SymKEKData = new TElXMLKeyInfoSymmetricData(true);

								try
								{
									F = new FileInputStream(frmEnc.getKeyFile());
								}
								catch (Exception E)
								{
									E.printStackTrace();
									showErrorMessage(E.getMessage());
									return;
								}

								try
								{
									SymKEKData.getKey().load(F, 0);
								}
								finally
								{
									F.close();
								}

								Decryptor.setKeyEncryptionKeyData(SymKEKData);
							}
							else
							{
								if (X509KeyData != null)
									X509KeyData.Destroy();
								if (PGPKeyData != null)
									PGPKeyData.Destroy();
								RSAKeyData = new TElXMLKeyInfoRSAData(true);
								RSAKeyData.getRSAKeyMaterial().setPassphrase(frmEnc.getPassphrase());
								X509KeyData = new TElXMLKeyInfoX509Data(true);
								PGPKeyData = new TElXMLKeyInfoPGPData(true);

								try
								{
									F = new FileInputStream(frmEnc.getKeyFile());
								}
								catch (Exception E)
								{
									E.printStackTrace();
									showErrorMessage(E.getMessage());
									return;
								}

								try
								{
									RSAKeyData.getRSAKeyMaterial().loadSecret(F, 0);
								}
								catch(Exception ex) {}
            
								if (!RSAKeyData.getRSAKeyMaterial().getSecretKey())
								{
									LoadCertificate(F, frmEnc.getKeyFile(), frmEnc.getPassphrase(), X509KeyData);
								}
								F.close();
								
								try
								{
									lF = new TElFileStream(frmEnc.getKeyFile(), "rw", true);
								}
								catch (Exception E)
								{
									E.printStackTrace();
									showErrorMessage(E.getMessage());
									return;
								}								
								
								if (!RSAKeyData.getRSAKeyMaterial().getPublicKey() && (X509KeyData.getCertificate() == null))
								{
									TElPGPSecretKey skey = new TElPGPSecretKey();
									try
									{
										skey.setPassphrase(frmEnc.getPassphrase());
										skey.loadFromStream(lF);
										PGPKeyData.setSecretKey(skey);
									}
									catch(Exception ex)
									{
										PGPKeyData.setSecretKey(null);
									}
								}
								
								lF.Destroy();

								if (RSAKeyData.getRSAKeyMaterial().getSecretKey())
									Decryptor.setKeyEncryptionKeyData(RSAKeyData);
								else
									if (X509KeyData.getCertificate() != null)
									Decryptor.setKeyEncryptionKeyData(X509KeyData);
																																											  
								else
									if (PGPKeyData.getSecretKey() != null)
									Decryptor.setKeyEncryptionKeyData(PGPKeyData);
																							 
								else
								{
									showErrorMessage("Key not loaded.");
									return;
								}
							}
						}
						else
						{
							SymKeyData = new TElXMLKeyInfoSymmetricData(true);

							try
							{
								F = new FileInputStream(frmEnc.getKeyFile());
							}
							catch (Exception E)
							{
								E.printStackTrace();
								showErrorMessage(E.getMessage());
								return;
							}

							try
							{
								SymKeyData.getKey().load(F, 0);
							}
							finally
							{
								F.close();
							}

							Decryptor.setKeyData(SymKeyData);
						}

						i = Decryptor.decrypt(FXMLDocument);
						if (i != SBXMLEnc.SB_XML_ENC_ERROR_OK)
						{
							if ((!Decryptor.getEncryptKey() && (i == SBXMLEnc.SB_XML_ENC_ERROR_INVALID_KEY)) ||
								(Decryptor.getEncryptKey() && (i == SBXMLEnc.SB_XML_ENC_ERROR_INVALID_KEK)))
								showErrorMessage("Decryption failed. Bad key or data is corrupted.");
							else
							{
								showErrorMessage(String.format("Decryption failed. Error code: %s", i));
								return;
							}

							continue;
						}

						if (Decryptor.getEncryptedDataType() == SBXMLSec.xedtExternal)
						{
							try
							{
								lF = new TElFileStream(frmEnc.getExternalFile(), "rw", true);
							}
							catch (Exception E)
							{
								E.printStackTrace();
								showErrorMessage(E.getMessage());
								return;
							}

							try
							{
								if (Decryptor.getDecryptedData().length > 0)
									lF.write(Decryptor.getDecryptedData(), 0, Decryptor.getDecryptedData().length);
							}
							finally
							{
								lF.Destroy();
							}

							showMessage("", "Data saved successfully.");
						}
						else
						{
							if (Decryptor.getDecryptedNode() != null)
							{
								if (Node instanceof TElXMLDOMDocument)
									FXMLDocument.replaceChild(Decryptor.getDecryptedNode(), FXMLDocument.getFirstChild());
								else
									Node.getParentNode().replaceChild(Decryptor.getDecryptedNode(), Node);

								Decryptor.setDecryptedNode(null);
							}
							else
								if ((Decryptor.getEncryptedDataType() == SBXMLSec.xedtContent) &&
								(Decryptor.getDecryptedNodeList() != null))
							{
								T = Node.getParentNode();
								for (i = 0; i < Decryptor.getDecryptedNodeList().getLength(); i++)
									T.insertBefore(Decryptor.getDecryptedNodeList().getItem(i).cloneNode(true), Node);

								T.removeChild(Node);
							}

							updateXML();
						}

						break;
					}
					else
						break;
				}
			}
			finally
			{
				Decryptor.Destroy();
				if (X509KeyData != null)
					X509KeyData.Destroy();
				if (PGPKeyData != null)
					PGPKeyData.Destroy();
			}
	}

	protected void encrypt() throws IOException {
		TElXMLEncryptor Encryptor;
		TElXMLKeyInfoSymmetricData SymKeyData, SymKEKData = null;
		TElXMLKeyInfoRSAData RSAKeyData = null;
		TElXMLKeyInfoX509Data X509KeyData = null;
		TElXMLKeyInfoPGPData PGPKeyData = null;
		FileInputStream F;
		TElFileStream lF;
		TElXMLDOMNode Node, EncNode;
		byte[] Buf;
		
		SymKeyData = null;
		SymKEKData = null;
		RSAKeyData = null;
		X509KeyData = null;
		PGPKeyData = null;
		EncDialog frmEnc = new EncDialog();
		frmEnc.setModal(true);
		frmEnc.setLockOpt(false);
		frmEnc.setVisible(true);
		
		if (frmEnc.isOK())
		{
			Encryptor = new TElXMLEncryptor();
			try
			{
				Encryptor.setEncryptKey(frmEnc.getEncryptKey());
				Encryptor.setEncryptionMethod(frmEnc.getEncryptionMethod());
				Encryptor.setKeyName(frmEnc.getKeyName());
				Encryptor.setEncryptedDataType(frmEnc.getEncryptedDataType());
				if (Encryptor.getEncryptKey())
				{
					Encryptor.setKeyEncryptionType(frmEnc.getKeyEncryptionType());
					Encryptor.setKeyTransportMethod(frmEnc.getKeyTransportMethod());
					Encryptor.setKeyWrapMethod(frmEnc.getKeyWrapMethod());

					SymKeyData = new TElXMLKeyInfoSymmetricData(true);
					// generate random Key & IV
					switch (Encryptor.getEncryptionMethod())
					{
						case SBXMLSec.xem3DES:
						{
							SymKeyData.getKey().generate(SBDES.T3DESKeySize * 8);
							SymKeyData.getKey().generateIV(8 * 8);
							break;
						}

						case SBXMLSec.xemAES:
						{
							SymKeyData.getKey().generate(32 * 8);
							SymKeyData.getKey().generateIV(16 * 8);
							break;
						}

						case SBXMLSec.xemCamellia:
						{
							SymKeyData.getKey().generate(32 * 8); // 16, 24, 32
							SymKeyData.getKey().generateIV(16 * 8);
							break;
						}

						case SBXMLSec.xemDES:
						{
							SymKeyData.getKey().generate(SBDES.TDESKeySize * 8);
							SymKeyData.getKey().generateIV(8 * 8);
							break;
						}

						case SBXMLSec.xemRC4:
						{
							SymKeyData.getKey().generate(16 * 8); // 1..32
							break;
						}
					}

					Encryptor.setKeyData(SymKeyData);

					if (Encryptor.getKeyEncryptionType() == SBXMLSec.xetKeyWrap)
					{
						SymKEKData = new TElXMLKeyInfoSymmetricData(true);

						try
						{
							F = new FileInputStream(frmEnc.getKeyFile());
						}
						catch (Exception ex)
						{
							ex.printStackTrace();
							showErrorMessage(ex.getMessage());
							return;
						}

						try
						{
							SymKEKData.getKey().load(F, 0);
						}
						finally
						{
							F.close();
						}

						Encryptor.setKeyEncryptionKeyData(SymKEKData);
					}
					else
					{ // xetKeyTransport
						RSAKeyData = new TElXMLKeyInfoRSAData(true);
						RSAKeyData.getRSAKeyMaterial().setPassphrase(frmEnc.getPassphrase());
						X509KeyData = new TElXMLKeyInfoX509Data(true);
						PGPKeyData = new TElXMLKeyInfoPGPData(true);

						try
						{
							F = new FileInputStream(frmEnc.getKeyFile());
						}
						catch (Exception ex)
						{
							ex.printStackTrace();
							showErrorMessage(ex.getMessage());
							return;
						}

						try 
						{
							RSAKeyData.getRSAKeyMaterial().loadPublic(F, 0);
						}
						catch (Exception ex) 
						{
							;
						}								 

						if (!RSAKeyData.getRSAKeyMaterial().getPublicKey())
						{
							try
							{
								F.close();
								F = new FileInputStream(frmEnc.getKeyFile());
								
								RSAKeyData.getRSAKeyMaterial().loadSecret(F, 0);
							}
							catch (Exception ex) {}
								 
						}

						if (!RSAKeyData.getRSAKeyMaterial().getPublicKey())
						{
							LoadCertificate(F, frmEnc.getKeyFile(), frmEnc.getPassphrase(), X509KeyData);
						}
						
						F.close();

						try
						{
							lF = new TElFileStream(frmEnc.getKeyFile(), "rw", true);
						}
						catch (Exception ex)
						{
							ex.printStackTrace();
							showErrorMessage(ex.getMessage());
							return;
						}
						
						if (!RSAKeyData.getRSAKeyMaterial().getPublicKey() &&
							(X509KeyData.getCertificate() == null))
						{
							TElPGPPublicKey pkey = new TElPGPPublicKey();
							try 
							{
								pkey.loadFromStream(lF);
								PGPKeyData.setPublicKey(pkey);
							}
							catch(Exception ex)
							{
								PGPKeyData.setPublicKey(null);
							}

							if (PGPKeyData.getPublicKey() == null)
							{
								TElPGPSecretKey skey = new TElPGPSecretKey();
								try
								{
									skey.setPassphrase(frmEnc.getPassphrase());
									skey.loadFromStream(lF);
									PGPKeyData.setSecretKey(skey);
								}
								catch(Exception ex)
								{
									PGPKeyData.setSecretKey(null);
								}
							}
						}

						lF.Free();

						if (RSAKeyData.getRSAKeyMaterial().getPublicKey())
							Encryptor.setKeyEncryptionKeyData(RSAKeyData);
						else
							if (X509KeyData.getCertificate() != null)
							Encryptor.setKeyEncryptionKeyData(X509KeyData);
																																															   
						else
							if ((PGPKeyData.getPublicKey() != null) ||
							(PGPKeyData.getSecretKey() != null))
							Encryptor.setKeyEncryptionKeyData(PGPKeyData);																																					 
						else
						{
							showErrorMessage("Key not loaded.");
							return;
						}
					}
				}
				else
				{
					SymKeyData = new TElXMLKeyInfoSymmetricData(true);

					try
					{
						F = new FileInputStream(frmEnc.getKeyFile());
					}
					catch (Exception ex)
					{
						ex.printStackTrace();
						showErrorMessage(ex.getMessage());
						return;
					}

					try
					{
						SymKeyData.getKey().load(F, 0);
					}
					finally
					{
						F.close();
					}

					// generate random IV
					if ((Encryptor.getEncryptionMethod() == SBXMLSec.xem3DES) ||
						(Encryptor.getEncryptionMethod() == SBXMLSec.xemDES))
						SymKeyData.getKey().generateIV(8 * 8);
					else
						SymKeyData.getKey().generateIV(16 * 8);

					Encryptor.setKeyData(SymKeyData);
				}

				if (Encryptor.getEncryptedDataType() == SBXMLSec.xedtExternal)
				{
					Encryptor.setMimeType(frmEnc.getMimeType());

					try
					{
						lF = new TElFileStream(frmEnc.getExternalFile(), "rw", true);
					}
					catch (Exception ex)
					{
						ex.printStackTrace();
						showErrorMessage(ex.getMessage());
						return;
					}

					try
					{
						int length = (int) lF.getLength();
						Buf = new byte[length];
						if (length > 0)
							F.read(Buf, 0, Buf.length);
					}
					finally 
					{
						lF.Free();
					}

					Encryptor.encrypt(Buf);

					FXMLDocument.Free();
					FXMLDocument = new TElXMLDOMDocument();

					try
					{
						EncNode = Encryptor.save(FXMLDocument);
					}
					catch (Exception ex)
					{
						ex.printStackTrace();
						showErrorMessage("Encrypted data saving failed. ({0})" + ex.getMessage());
						return;
					}

					FXMLDocument.appendChild(EncNode);
					updateXML();
				}
				else
				{
				    TreePath[] paths = tvXML.getSelectionPaths();

					if (paths.length == 0)
					{
						showMessage("", "Please, select node for encryption.");
						return;
					}

					Node = getFirstNode(paths);

					Encryptor.encrypt(Node);

					try
					{
						EncNode = Encryptor.save(FXMLDocument);
					}
					catch (Exception ex)
					{
						ex.printStackTrace();
						showMessage("", "Encrypted data saving failed. ({0})" + ex.getMessage());
						return;
					}

					if (Encryptor.getEncryptedDataType() == SBXMLSec.xedtElement)
						Node.getParentNode().replaceChild(EncNode, Node);
					else // xedtContent
					{
						if (Node instanceof TElXMLDOMElement)
						{
							while (Node.getLastChild() != null)
							{
								Node.removeChild(Node.getLastChild());
							}

							Node.appendChild(EncNode);
						}
						else
							Node.getParentNode().replaceChild(EncNode, Node);
					}
					updateXML();
				}
			}
			catch (Exception ex){
				ex.printStackTrace();
				showErrorMessage(ex.getMessage());
			}
			finally
			{
				Encryptor.Free();
				if (X509KeyData != null)
					X509KeyData.Free();
				if (PGPKeyData != null)
					PGPKeyData.Free();
			}	
		}
	}

	private void LoadCertificate(FileInputStream F, String path, String Password, TElXMLKeyInfoX509Data X509KeyData) {
		int CertFormat;
		X509KeyData.setCertificate(new TElX509Certificate());
		try
		{
			CertFormat = TElX509Certificate.detectCertFileFormat(path);

			switch (CertFormat)
			{
				case SBX509.cfDER: 
				{
					X509KeyData.getCertificate().loadFromStream(F, 0);
					break;
				}
				case SBX509.cfPEM: 
				{
					X509KeyData.getCertificate().loadFromStreamPEM(F, Password, 0);
					break;
				}
				case SBX509.cfPFX: 
				{
					X509KeyData.getCertificate().loadFromStreamPFX(F, Password, 0);
					break;
				}
				default:
				{
					X509KeyData.getCertificate().Free();
					X509KeyData.setCertificate(null);
					break;
				}
			}
		}
		catch (Exception ex)
		{
			X509KeyData.getCertificate().Free();
			X509KeyData.setCertificate(null);
		}
	}

	protected void clear() {
		FXMLDocument.Free();
		FXMLDocument = new TElXMLDOMDocument();
		updateXML();
	}

	protected void deleteSelectedNodes() {
	    DefaultMutableTreeNode node;
	    DefaultTreeModel model = (DefaultTreeModel) (tvXML.getModel());
	    TreePath[] paths = tvXML.getSelectionPaths();
	    for (int i = 0; i < paths.length; i++) {
	      node = (DefaultMutableTreeNode) (paths[i].getLastPathComponent());
	      model.removeNodeFromParent(node);
	    }
	}

	protected void saveXML() {
		TElFileStream F = null;
		try
		{
			F = new TElFileStream(edXMLFile.getText(), "rw", true);
			FXMLDocument.saveToStream(F, SBXMLDefs.xcmNone, "");
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
			showErrorMessage(ex.getMessage());
			return;
		}
		if (F != null)
			F.Free();		
	}

	static void showErrorMessage(String msg){
		JOptionPane.showMessageDialog(null, msg, "Error", JOptionPane.ERROR_MESSAGE);
	}
	
	static void showMessage(String caption, String msg) {
		JOptionPane.showMessageDialog(null, msg, caption, JOptionPane.INFORMATION_MESSAGE);
	}	

	protected void loadXML(String path) {
		TElFileStream F = null;
		try
		{
			F = new TElFileStream(edXMLFile.getText(), "rw", true);
			FXMLDocument.loadFromStream(F);
		}
		catch (Exception e)
		{
			e.printStackTrace();
			showErrorMessage(e.getMessage());
			return;
		}

		if (F != null)
			F.Free();

		updateXML();		
	}

	private void updateXML() {
		mmXML.removeAll();
	
		try {
			rootNode.removeAllChildren();
			rootNode = updateXMLAddNode(null, FXMLDocument);	
		} catch (Exception e) {
			e.printStackTrace();
			showErrorMessage(e.getMessage());
		}
		reloadTree();		
		expandTree();
	}
    
	private void expandTree() {	
	    int row = 0;
	    while (row < tvXML.getRowCount()) {
	      tvXML.expandRow(row);
	      row++;
	    }
	}
	
	private void reloadTree() {
		TreeModel model = tvXML.getModel();
	    ((DefaultTreeModel) model).reload();
	}

	class NodeData {
		String title;
		TElXMLDOMNode mNode;
		public NodeData(TElXMLDOMNode node, String s) {
			mNode = node;
			title = s;
		}

		public TElXMLDOMNode getNode(){
			return mNode;
		}
		
		public String toString()
		{ 
			return title;
		}
	}
	
	private DefaultMutableTreeNode updateXMLAddNode(DefaultMutableTreeNode Sibling, TElXMLDOMNode Node)
	{
		TElXMLDOMNode T;
		DefaultMutableTreeNode AttrNode;
		DefaultMutableTreeNode Result;
		TElXMLDOMNamedNodeMap Attributes;
		int i;
		String s;
		if (Node instanceof TElXMLDOMDocument)
			s = ((TElXMLDOMDocument)Node).getLocalName();
		else if (Node instanceof TElXMLDOMElement) 
			s = ((TElXMLDOMElement)Node).getNodeName();
		else if (Node instanceof TElXMLDOMAttr) 
			s = ((TElXMLDOMAttr)Node).getNodeName();
		else
			s = Node.getNodeName();

		Result = new DefaultMutableTreeNode(s);
		Result.setUserObject(new NodeData(Node, s));

		if (Sibling != null)
			Sibling.add(Result);
		else
		{
			if (Node instanceof TElXMLDOMDocument)
			{
				rootNode = new DefaultMutableTreeNode(s);
				rootNode.setUserObject(Node);
				DefaultTreeModel model = (DefaultTreeModel) (tvXML.getModel());
				model.setRoot(Result);
			} else
				rootNode.add(Result);
		}
		
		if (Node instanceof TElXMLDOMElement)
		{
			Attributes = ((TElXMLDOMElement)Node).getAttributes();
			if ((Attributes != null) && (Attributes.size() > 0))
			{
				AttrNode = Result;
				for (i = 0; i < Attributes.size(); i++)
					updateXMLAddNode(AttrNode, (TElXMLDOMNode)Attributes.get(i));
			}
		}

		if (Node instanceof TElXMLDOMAttr)
			return Result;

		T = Node.getFirstChild();
		while (T != null)
		{
			if ((T instanceof TElXMLDOMElement) ||
				(T instanceof TElXMLDOMAttr) ||
				((T instanceof TElXMLDOMText) && (((TElXMLDOMText)T).getNodeValue().trim().length() > 0)))
				updateXMLAddNode(Result, T);

			T = T.getNextSibling();
		}

		return Result;
	}

	protected String getXMLFileName() {
		JFileChooser fc = new JFileChooser();

	    int returnVal = fc.showOpenDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	}
	
	TElXMLDOMNode getFirstNode(TreePath[] paths){
		return ((NodeData)((DefaultMutableTreeNode)paths[0].getLastPathComponent()).getUserObject()).getNode();
	}
	
	void onNodeSelect() {
	    TreePath[] paths = tvXML.getSelectionPaths();

	    if (paths != null && paths.length > 0)
	    {
			TElXMLDOMNode N = getFirstNode(paths);
			String s, nt;
			if (N instanceof TElXMLDOMAttr)
				s = ((TElXMLDOMAttr)N).getNodeValue();
			else
				s = N.getOuterXML();

			lNamespace.setText(N.getNamespaceURI());
			mmXML.setText(s.replace("\n", "\r\n"));
			if (N instanceof TElXMLDOMAttr)
				nt = "Attribute";
			else
				if (N instanceof TElXMLDOMElement)
			{
				if ((N.getParentNode() != null) &&
					!(N.getParentNode() instanceof TElXMLDOMDocument))
					nt = "Element";
				else
					nt = "Root element";
			}
			else
				if (N instanceof TElXMLDOMText) 
				nt = "Text";
			else
				if (N instanceof TElXMLDOMComment)
				nt = "Comment";
			else
				if (N instanceof TElXMLDOMDocument)
				nt = "Document";
			else
				nt = "Unknown";

			lNodeType.setText(nt);
		}
		else
		{
			mmXML.setText("");
			lNodeType.setText("None");
			lNamespace.setText("");
		}		
	}
}
