import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.JLabel;
import javax.swing.JTextField;

import SecureBlackbox.ZIP.*;

import java.io.*;

import javax.swing.JComboBox;
import javax.swing.JCheckBox;
import javax.swing.JPasswordField;
import javax.swing.DefaultComboBoxModel;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.SwingConstants;


public class ArchiveOptionsDialog extends JDialog implements ActionListener {
	private static final long serialVersionUID = 9082014456767725674L;
	private final JPanel contentPanel = new JPanel();
	private JTextField textField;
	private JPasswordField textBoxPassword;
	private JPasswordField textBoxPasswordConfirmation;
	
	private boolean isNeedCreate;
	
	JComboBox<String> comboBoxCompressionAlgorithm;
	JComboBox<String> comboBoxCompressionLevel;
	JComboBox<String> comboBoxEncryption;
	JComboBox<String> comboBoxEncryptionAlgorithm;

	JButton btnOK;
	JCheckBox checkBoxCompressDirectory;
	JCheckBox checkBoxEncryptDirectory;
	JLabel labelCompressionLevel;
	JLabel labelEncryptionAlgorithm;
	JLabel labelCompressionAlgorithm;
	JLabel labelPassword;
	JLabel labelPasswordConfirmation;
	
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			ArchiveOptionsDialog dialog = new ArchiveOptionsDialog();
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog.
	 */
	public ArchiveOptionsDialog() {
		setTitle("Archive properties");
		setBounds(100, 100, 550, 300);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		
		JLabel lblNewLabel = new JLabel("Archive File");
		lblNewLabel.setBounds(10, 11, 71, 14);
		contentPanel.add(lblNewLabel);
		
		textField = new JTextField();
		textField.setBounds(79, 8, 353, 20);
		contentPanel.add(textField);
		textField.setColumns(10);
		
		JButton btnChoose = new JButton("Choose...");
		btnChoose.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				textField.setText(getFileName());
			}
		});
		btnChoose.setBounds(442, 7, 90, 23);
		contentPanel.add(btnChoose);
		
		JPanel panel = new JPanel();
		panel.setBounds(10, 36, 235, 180);
        panel.setBorder(BorderFactory.createTitledBorder("Compression"));
		contentPanel.add(panel);
		panel.setLayout(null);
		
		labelCompressionAlgorithm = new JLabel("Algorithm");
		labelCompressionAlgorithm.setHorizontalAlignment(SwingConstants.RIGHT);
		labelCompressionAlgorithm.setBounds(13, 25, 66, 14);
		panel.add(labelCompressionAlgorithm);
		
		comboBoxCompressionAlgorithm = new JComboBox<String>();
		comboBoxCompressionAlgorithm.setBounds(100, 21, 125, 22);
		comboBoxCompressionAlgorithm.setModel(new DefaultComboBoxModel<String>(new String[] {"Stored", "Deflate", "BZip2"}));
		panel.add(comboBoxCompressionAlgorithm);
		
		labelCompressionLevel = new JLabel("Level");
		labelCompressionLevel.setHorizontalAlignment(SwingConstants.RIGHT);
		labelCompressionLevel.setBounds(13, 54, 66, 14);
		panel.add(labelCompressionLevel);
		
		comboBoxCompressionLevel = new JComboBox<String>();
		comboBoxCompressionLevel.setBounds(100, 50, 126, 22);
		comboBoxCompressionLevel.setModel(new DefaultComboBoxModel<String>(new String[] {"Fastest", "Low", "Normal", "High"}));
		panel.add(comboBoxCompressionLevel);
		
		checkBoxCompressDirectory = new JCheckBox("Compress directory");
		checkBoxCompressDirectory.setBounds(13, 91, 150, 23);
		panel.add(checkBoxCompressDirectory);
		
		JPanel panel_1 = new JPanel();
		panel_1.setBounds(245, 36, 287, 180);
		panel_1.setBorder(BorderFactory.createTitledBorder("Security"));
		contentPanel.add(panel_1);
		panel_1.setLayout(null);
		
		JLabel labelEncryption = new JLabel("Encryption");
		labelEncryption.setBounds(14, 25, 81, 14);
		panel_1.add(labelEncryption);
		
		comboBoxEncryption = new JComboBox<String>();
		comboBoxEncryption.setBounds(124, 21, 153, 22);
		comboBoxEncryption.setModel(new DefaultComboBoxModel<String>(new String[] {"None", "Zip (weak)", "WinZip AES", "PKWare Strong Encryption"}));
		panel_1.add(comboBoxEncryption);
		
		labelEncryptionAlgorithm = new JLabel("Algorithm");
		labelEncryptionAlgorithm.setBounds(14, 50, 81, 14);
		panel_1.add(labelEncryptionAlgorithm);
		
		comboBoxEncryptionAlgorithm = new JComboBox<String>();
		comboBoxEncryptionAlgorithm.setBounds(124, 46, 153, 22);
		comboBoxEncryptionAlgorithm.setModel(new DefaultComboBoxModel<String>(new String[] {"AES-128", "AES-192", "AES-256", "Blowfish", "Twofish"}));
		panel_1.add(comboBoxEncryptionAlgorithm);
		
		checkBoxEncryptDirectory = new JCheckBox("Encrypt directory");
		checkBoxEncryptDirectory.setBounds(14, 75, 175, 23);
		panel_1.add(checkBoxEncryptDirectory);
		
		labelPassword = new JLabel("Password");
		labelPassword.setBounds(14, 108, 60, 14);
		panel_1.add(labelPassword);
		
		textBoxPassword = new JPasswordField();
		textBoxPassword.setBounds(98, 105, 124, 20);
		panel_1.add(textBoxPassword);
		
		labelPasswordConfirmation = new JLabel("Confirmation");
		labelPasswordConfirmation.setBounds(14, 136, 80, 14);
		panel_1.add(labelPasswordConfirmation);
		
		textBoxPasswordConfirmation = new JPasswordField();
		textBoxPasswordConfirmation.setBounds(98, 133, 124, 20);
		panel_1.add(textBoxPasswordConfirmation);
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				btnOK = new JButton("OK");
				btnOK.setEnabled(false);
				btnOK.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						isNeedCreate = true;
						setVisible(false);
					}
				});
				btnOK.setActionCommand("OK");
				buttonPane.add(btnOK);
				getRootPane().setDefaultButton(btnOK);
			}
			{
				JButton cancelButton = new JButton("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						dispose();
					}
				});
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
			}
		}
		addFieldsListener(this);
		refreshControlsVisibility();
	}
	
	public void addFieldsListener(final ActionListener l) {
		comboBoxEncryption.addActionListener(l);
		comboBoxCompressionAlgorithm.addActionListener(l);
		addPasswordDocumentLisner(textBoxPassword, l);
		addPasswordDocumentLisner(textBoxPasswordConfirmation, l);
		addTextDocumentLisner(textField, l);
		checkBoxEncryptDirectory.addActionListener(l);
	}		 
	
	public void addTextDocumentLisner(final JTextField txt, final ActionListener l) {
		txt.getDocument().addDocumentListener(new DocumentListener() {
			public void changedUpdate(DocumentEvent e) {
				l.actionPerformed(new ActionEvent(txt, 0, "changed"));
			}

			public void insertUpdate(DocumentEvent arg0) {
				l.actionPerformed(new ActionEvent(txt, 1, "insert"));
			}

			public void removeUpdate(DocumentEvent e) {			
				l.actionPerformed(new ActionEvent(txt, 2, "remove"));
			}
		});
	} 
	
	public void addPasswordDocumentLisner(final JPasswordField txt, final ActionListener l) {
		txt.getDocument().addDocumentListener(new DocumentListener() {
			public void changedUpdate(DocumentEvent e) {
				l.actionPerformed(new ActionEvent(txt, 0, "changed"));
			}

			public void insertUpdate(DocumentEvent arg0) {
				l.actionPerformed(new ActionEvent(txt, 1, "insert"));
			}

			public void removeUpdate(DocumentEvent e) {			
				l.actionPerformed(new ActionEvent(txt, 2, "remove"));
			}
		});
	}	 
	
	String getNewArchiveFullPath() {
		return textField.getText();
	}
	
	String getFileName(){
		JFileChooser fc = new JFileChooser();
		File f = new File("archive.zip");
		fc.setSelectedFile(f);

	    int returnVal = fc.showSaveDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	}

	public boolean getIsCreateArch() {
		return isNeedCreate && textField.getText().length() > 0;
	}

	public int getCompressionAlg() {
		switch (comboBoxCompressionAlgorithm.getSelectedIndex())
		{
			case 1 : return SBZipUtils.ZIP_COMPRESSION_DEFLATE;
			case 2 : return SBZipUtils.ZIP_COMPRESSION_BZIP2;
			default : return SBZipUtils.ZIP_COMPRESSION_STORED;
		}
	}

	public int getCompressionLevel() {
		switch (comboBoxCompressionLevel.getSelectedIndex())
		{
			case 0 : return 1;
			case 1 : return 3;
			case 2 : return 6;
			default : return 9;
		}
	}

	public boolean getIsDirCompressed() {
		return checkBoxCompressDirectory.isSelected();
	}

	public boolean getIsEncrypt() {
		return comboBoxEncryption.getSelectedIndex() > 0;
	}

	public int getEncryptionIndex() {
		return comboBoxEncryptionAlgorithm.getSelectedIndex();
	}

	public int getWinZipAesKeySize() {
		switch (comboBoxEncryptionAlgorithm.getSelectedIndex())
		{
			case 0 : return 128;
			case 1 : return 192;
			default : return 256;
		}
	}

	public boolean getIsDirEncrypt() {
		return checkBoxEncryptDirectory.isSelected();
	}

	public String getPassword() {
		return new String(textBoxPassword.getPassword());
	}

	public int getEncryptionAlg() {
		switch (comboBoxEncryption.getSelectedIndex())
		{
			case 0 : return SBZipUtils.ZIP_ENCRYPTION_AES128;
			case 1 : return SBZipUtils.ZIP_ENCRYPTION_AES192;
			case 2 : return SBZipUtils.ZIP_ENCRYPTION_AES256;
			case 3 : return SBZipUtils.ZIP_ENCRYPTION_BLOWFISH;
			case 4 : return SBZipUtils.ZIP_ENCRYPTION_TWOFISH;
			default : return SBZipUtils.ZIP_ENCRYPTION_AES128;
		}
	}

	public void actionPerformed(ActionEvent e) {
		refreshControlsVisibility();
		
		if (getNewArchiveFullPath().length() == 0)
		{
			btnOK.setEnabled(false);
			return;
		} else
		{
			btnOK.setEnabled(true);
		}

		if ((comboBoxEncryption.getSelectedIndex() != 0) && getPassword().length() == 0) {
			btnOK.setEnabled(false);
			return;
		}
		
		if ((comboBoxEncryption.getSelectedIndex() != 0))
			btnOK.setEnabled(getPassword().compareTo(new String (textBoxPasswordConfirmation.getPassword())) == 0);
	}
	
	private void refreshControlsVisibility()
	{
		if (comboBoxCompressionAlgorithm.getSelectedIndex() == 0)
		{
			labelCompressionLevel.setVisible(false);
			comboBoxCompressionLevel.setVisible(false);
			checkBoxCompressDirectory.setVisible(false);
		}
		else
		{
			labelCompressionLevel.setVisible(true);
			comboBoxCompressionLevel.setVisible(true);
			checkBoxCompressDirectory.setVisible(true);
		}

		// checking encryption usage
		if (comboBoxEncryption.getSelectedIndex() == 0)
		{
			// no encryption
			labelEncryptionAlgorithm.setVisible(false);
			comboBoxEncryptionAlgorithm.setVisible(false);
			checkBoxEncryptDirectory.setVisible(false);
			labelPassword.setVisible(false);
			textBoxPassword.setVisible(false);
			labelPasswordConfirmation.setVisible(false);
			textBoxPasswordConfirmation.setVisible(false);
		}
		else
		{
			labelPassword.setVisible(true);
			textBoxPassword.setVisible(true);
			labelPasswordConfirmation.setVisible(true);
			textBoxPasswordConfirmation.setVisible(true);

			if (comboBoxEncryption.getSelectedIndex() == 1)
			{
				// zip old-style (traditional) weak encryption
				labelEncryptionAlgorithm.setVisible(false);
				comboBoxEncryptionAlgorithm.setVisible(false);
				checkBoxEncryptDirectory.setVisible(false);
			}
			else if (comboBoxEncryption.getSelectedIndex() == 2)
			{
				// WinZip AES encryption
				labelEncryptionAlgorithm.setVisible(true);
				comboBoxEncryptionAlgorithm.setVisible(true);
				comboBoxEncryptionAlgorithm.removeAllItems();
				comboBoxEncryptionAlgorithm.addItem("AES-128");
				comboBoxEncryptionAlgorithm.addItem("AES-192");
				comboBoxEncryptionAlgorithm.addItem("AES-256");
				comboBoxEncryptionAlgorithm.setSelectedIndex(0);
				checkBoxEncryptDirectory.setVisible(false);
			}
			else if (comboBoxEncryption.getSelectedIndex() == 3)
			{
				// PKWare strong encryption
				labelEncryptionAlgorithm.setVisible(true);
				comboBoxEncryptionAlgorithm.setVisible(true);
				comboBoxEncryptionAlgorithm.removeAllItems();
				comboBoxEncryptionAlgorithm.addItem("AES-128");
				comboBoxEncryptionAlgorithm.addItem("AES-192");
				comboBoxEncryptionAlgorithm.addItem("AES-256");
				comboBoxEncryptionAlgorithm.addItem("Blowfish");
				comboBoxEncryptionAlgorithm.addItem("Twofish");
				comboBoxEncryptionAlgorithm.setSelectedIndex(0);
				checkBoxEncryptDirectory.setVisible(true);
			}
		}
	}
}
